! -*- Mode: f90 -*-
MODULE mod_build
CONTAINS
   !!
   SUBROUTINE build_poly (x, y, pol )
!!!
!!! Build a polygone from arrays of coordinates
!!!
      USE declare
      USE u_polyg
      !!
      IMPLICIT NONE
      !!
      REAL (kind=rp), DIMENSION (:), INTENT (in) :: x, y
      TYPE (polyg), INTENT ( out) :: pol
      INTEGER (kind=il) :: n, i
      !!
      !! Check size
      n = SIZE (x)
      IF ( SIZE (y) /= n ) THEN
         pol%n = 0
         RETURN
      ENDIF
      !!
      pol%n = n
      DO i = 1, n
         pol%pt(i) = (/ x(i), y(i) /)
      END DO
      !!
      RETURN
      !!
   END SUBROUTINE build_poly
END MODULE mod_build
 
