! -*- Mode: f90 -*-
! ------------------------------------------------------------------
SUBROUTINE chrono ( kout)
   USE declare
   !!
   IMPLICIT NONE
   INTEGER (kind=r4), INTENT ( in) :: kout
   CHARACTER (len = 10) :: cldate, cltime, clzone
   INTEGER (kind=r4), DIMENSION ( 12) :: values
   REAL    (kind=r4), SAVE :: time, time0
   INTEGER (kind=r4), SAVE :: hour, hour0, min, min0, sec, sec0, mill, mill0
   REAL    (kind=r4) :: delai
   !!
   CALL DATE_AND_TIME ( cldate, cltime, clzone, values)
   !!
   READ ( unit = cltime, fmt = *) time
   IF ( time0 .LE. 0.0_r4 ) time0 = time
   !!
   CALL time2time ( time , hour , min , sec , mill )
   CALL time2time ( time0, hour0, min0, sec0, mill0)
   !!
   delai = (mill-mill0) + 1000*((sec-sec0) + (min-min0)*60)
   !!
   WRITE ( kout, FMT = '( "Heure : ", 1I2, "h", 1I2.2, "m", 1I2.2, "s", 1I3.3, " --> diff = ", 1F12.5, " secondes" )') &
      &  hour, min, sec, mill, delai / 1000.0
   time0 = time
   !!
CONTAINS
   SUBROUTINE time2time ( time, hour, min, sec, mill )
      IMPLICIT NONE
      !!
      REAL    (kind=r4), INTENT ( in) :: time
      INTEGER (kind=r4), INTENT ( out) :: hour, min, sec, mill
      REAL    (kind=r4) :: z
      !!
      hour = INT ( time/10000.0 )
      z    = time - REAL ( hour,KIND=r4) * 10000
      min  = INT ( z/100.0_r4)
      z    = z - REAL (min,KIND=r4)*100
      sec = INT ( z )
      z = ( z - REAL(sec,KIND=r4)) * 1000.0
      mill = INT ( z )
      !!
      RETURN
   END SUBROUTINE time2time
END SUBROUTINE chrono
