!-$$! -*- Mode: f90 -*-
!-$$!>
!-$$!!
!-$$!! Last phase for weights 
!-$$!! Atmospheric Model : LMD5, LMDz or spectral model with Gaussian grid
!-$$!!
!-$$SUBROUTINE correct_o2a
!-$$   
!-$$   !! Checking weights
!-$$   WRITE ( unit = nout, fmt = '( "Neighbors o2a     : ", 3I9  )' ) MINVAL (nva, nva /=0), MAXVAL (nva), jmo2a
!-$$   WRITE ( unit = nout, fmt = '( "Index o2a         : ", 2I9  )' ) MINVAL (ko2a, ko2a /= 0), MAXVAL (ko2a)
!-$$   jind = MINLOC(wo2a, wo2a /= 0.0_rl) ; ja = jind(2) ; jn = jind(1); jai = m2ai(ja) ; jaj = m2aj(ja)
!-$$   WRITE ( unit = nout, fmt = '( "Weights o2a mini : ", 4I6, 1E13.4, 3I6)' ) &
!-$$      & ja, jn, jai, jaj, wo2a(jn,ja), ko2a(jn,ja), m2oi(ko2a(jn,ja)), m2oj(ko2a(jn,ja))
!-$$   jind = MAXLOC(wo2a, wo2a /= 0.0_rl) ; ja = jind(2) ; jn = jind(1); jai = m2ai(ja) ; jaj = m2aj(ja)
!-$$   WRITE ( unit = nout, fmt = '( "Weights o2a maxi : ", 4I6, 1E13.4, 3I6)' ) &
!-$$      & ja, jn, jai, jaj, wo2a(jn,ja), ko2a(jn,ja), m2oi(ko2a(jn,ja)), m2oj(ko2a(jn,ja))
!-$$   !! Ocean mask interpolated to atm
!-$$   CALL inter_o2a ( REAL ( 1-iomskt, KIND = rl ), o2amask )
!-$$!$$$  WRITE (nout,*) 'Ocean mask interpolated to atm before normalisation'
!-$$!$$$  CALL prihre( RESHAPE(o2amask,(/jpai,jpaj/)),jpai,jpaj,1_il,jpai,1_il,1_il,jpaj,1_il,1.0_rl,INT(nout,kind=i4))
!-$$   
!-$$   WRITE ( nout, *) 'Low sea fraction before normalization'
!-$$   DO jn = 1, 12
!-$$      zzz = 10.0_rl**(-jn)
!-$$      WRITE ( nout, *) 'Classe : ', jn, COUNT ( o2amask .LE. zzz .AND. o2amask .GT. zzz/10.0_rl )
!-$$   END DO
!-$$   WRITE ( nout, *) 'High sea fraction'
!-$$   DO jn = 1, 12
!-$$      zzz = 10.0_rl**(-jn)
!-$$      WRITE ( nout, *) 'Classe : ', jn, COUNT ( 1.0_rl-o2amask .LE. zzz .AND. 1.0_rl-o2amask .GT. zzz/10.0_rl )
!-$$   END DO
!-$$   !! Remove small fractions
!-$$   WHERE ( o2amask <        epsfrac ) o2amask = 0.0_rl
!-$$   WHERE ( o2amask > 1.0_rl-epsfrac ) o2amask = 1.0_rl
!-$$
!-$$   DO jo = 1, jpon
!-$$      DO jn = 1, jma2o
!-$$         ja=ka2o(jn,jo)
!-$$         IF ( ja > 0 ) THEN
!-$$            IF ( o2amask(ja) < epsfrac ) THEN
!-$$               wa2o(jn,jo) = 0.0_rl
!-$$               ka2o(jn,jo) = 0_il
!-$$               wo2a(:,ja)  = 0.0_rl
!-$$               ko2a(:,ja)  = 0_il
!-$$            END IF
!-$$         END IF
!-$$      END DO
!-$$   END DO
!-$$   
!-$$   !! Gather weights
!-$$   ALLOCATE(ktemp(jpo2a), STAT=ierr) ; CALL chk_allo (ierr, 'ktemp(jpo2a)', lreset=.TRUE., crout='correct') 
!-$$   ALLOCATE(wtemp(jpo2a), STAT=ierr) ; CALL chk_allo (ierr, 'wtemp(jpo2a)')
!-$$   DO ja = 1, jpan
!-$$    ktemp = ko2a(:,ja) ; wtemp = wo2a(:,ja)
!-$$    ko2a(:,ja) = 0_il  ; wo2a(:,ja) = 0.0_rl
!-$$    kn = 1
!-$$    DO jn = 1, jmo2a
!-$$      IF ( ktemp(jn) /= 0_il ) THEN
!-$$          ko2a(kn,ja) =  ktemp(jn)
!-$$          wo2a(kn,ja) =  wtemp(jn)
!-$$          kn = kn + 1
!-$$      END IF
!-$$    END DO
!-$$  END DO
!-$$  nva = COUNT ( ko2a /= 0, DIM = 1)
!-$$  jmo2a = MAXVAL ( COUNT ( ko2a /= 0, DIM = 1))
!-$$  WRITE ( unit = nout, fmt = * ) 'Nombre de voisins : ', jmo2a
!-$$  DEALLOCATE(ktemp) ; DEALLOCATE(wtemp)
!-$$
!-$$  WRITE ( nout, *) 'Calling normalization '
!-$$  CALL norma ( knorma2o = 0, knormo2a = normo2a )
!-$$ 
!-$$  !! Periodicity atm
!-$$  DO jn = 1, jpo2a
!-$$    CALL lbc ( wo2a(jn,:) , naperio, 'T', jpai, jpaj)
!-$$    CALL lbc ( ko2a(jn,:) , naperio, 'T', jpai, jpaj)
!-$$  END DO
!-$$  CALL lbc ( o2amask, naperio, 'T', jpai, jpaj)
!-$$   
!-$$
!-$$  WRITE ( unit = nout, fmt = '("Oce->Atm : ", 1I9, " non-null adresses, ", 1I9, " non-null weights ")') & 
!-$$     & COUNT ( wo2a > 0.0_rl), COUNT ( ko2a > 0)
!-$$
!-$$
!-$$  RETURN
!-$$END SUBROUTINE correct_o2a
!-$$
SUBROUTINE correct_a2o
   
 !! Checking weights
  WRITE ( unit = nout, fmt = '( "Neighbors a2o     : ", 3I9  )' ) MINVAL (nvo, nvo /=0), MAXVAL (nvo), jma2o
  WRITE ( unit = nout, fmt = '( "Index a2o         : ", 2I9  )' ) MINVAL (ka2o, ka2o /= 0), MAXVAL (ka2o)
  jind = MINLOC(wa2o, wa2o /= 0.0_rl) ; jo = jind(2) ; jn = jind(1); joi = m2oi(jo) ; joj = m2oj(jo)
  WRITE ( unit = nout, fmt = '( "Weights a2o mini : ", 4I6, 1E13.4, 3I6)' ) &
     &jo, jn, joi, joj, wa2o(jn,jo), ka2o(jn,jo), m2ai(ka2o(jn,jo)), m2aj(ka2o(jn,jo))
  jind = MAXLOC(wa2o, wa2o /= 0.0_rl) ; jo = jind(2) ; jn = jind(1); joi = m2oi(jo) ; joj = m2oj(jo)
  WRITE ( unit = nout, fmt = '( "Weights a2o maxi : ", 4I6, 1E13.4, 3I6)' ) &
     & jo, jn, joi, joj, wa2o(jn,jo), ka2o(jn,jo), m2ai(ka2o(jn,jo)), m2aj(ka2o(jn,jo))

  !! Atm mask interpolated to oce
  CALL inter_a2o ( REAL ( 1-iamskt, KIND = rl ), a2omask )
!$$$  WRITE (nout,*) 'Atm mask interpolated to oce before normalization'
!$$$  CALL prihre( RESHAPE(a2omask,(/jpoi,jpoj/)),jpoi,jpoj,1_il,jpoi,1_il,1_il,jpoj,1_il,1.0_rl,INT(nout,kind=i4))
