! -*- Mode: f90 -*-
MODULE mod_cotes_a
CONTAINS
   SUBROUTINE cotes_a
      !>
      !! Compute weights by exact by distance
      !!
      USE declare
      USE modeles
      USE math
      USE formula
      USE mod_proj
      USE mod_polom
      USE mod_lbc
      !!
      IMPLICIT NONE
      !!

      REAL (kind=rp) :: zg !> Distance of boxes 
      REAL (kind=rp), DIMENSION (:), ALLOCATABLE :: xat_p, yat_p

      INTEGER (kind=il) :: kproj = 2 !> Type of projection
      INTEGER (kind=il) :: ja, jo, jo2, jai, jaj, joi, joj, jn, nto, no !> Dummy indexes
      LOGICAL (kind=il) :: lwrite  !> For test outputs
      INTEGER (kind=il) :: ld = 1 , ld_t !> Debug flag
      INTEGER (kind=il) :: np=0 ! Comptage de print
      REAL (kind = rl) :: xoloninf, xolonsup, yolatinf, yolatsup
      REAL (kind = rl) :: xaloninf, xalonsup, yalatinf, yalatsup
      REAL (kind=rl) :: dx, dy
      INTEGER (kind=il) :: kerr_p(jpai+1) !> Error code of projection
      !!
      !! Generation of weights
      !!
      ! Initialisation
      nto = 0
      jma2o = 0 ; wa2o = zero ; ka2o = 0 ; nvo = 0
      nborda = 0 ; nbordo = 0
      wasum = 0.0_rl ; wosum = 0.0_rl
      WRITE (unit = nout, fmt = *)
      WRITE ( unit = nout, fmt = *) 'Number of points to compute : ', jpan
      !!
      dx = MAXVAL ( ABS (xae-xaw))
      dy = MAXVAL ( ABS (yan-yas))
      WRITE(nout,*) 'cotes_a : dx, dy : ', dx, dy
      !
      AtmosJ: DO jaj = 1, jpaj ! Loop over atmospheric grid points
         ja = m1a (1, jaj)
         AtmosI: DO jai = 1, jpai
            ja = m1a (jai, jaj)
            ld_t = ld
            lwrite = .FALSE. 
            no = 0
            IF (ld_t <= 1 .AND. MOD(ja,100) .EQ. 0 ) THEN
               WRITE (UNIT=nout, FMT='(1I8," ")', ADVANCE='no') ja
               np = np + 1
               IF (np > 15 ) THEN
                  WRITE (UNIT=nout, FMT='(" ")') 
                  CALL FLUSH(nout)                  
                  np=0
               END IF
            ENDIF
            xalonsup = MAXVAL (xa_ed(ja,1:jpae))
            xaloninf = MINVAL (xa_ed(ja,1:jpae)) 
            yalatsup = MAXVAL (ya_ed(ja,1:jpae))
            yalatinf = MINVAL (ya_ed(ja,1:jpae))

!-$$            IF (iamskt (ja) == 1 .AND. .NOT. lmaska) THEN ! This point is not considered
!-$$               IF (ld_t >= 2)  WRITE ( nout, fmt ='("Atm rejected (Atm masked)",1I6,2I4)' ) ja, jai, jaj
!-$$               CYCLE  AtmosI
!-$$            END IF

!-$$            IF ( iamskt (ja) == 1 .AND. .NOT. lacot(ja) ) THEN ! This point is not considered
!-$$               IF (ld_t >= 2)  WRITE ( nout, fmt ='("Atm rejected (Atm masked)",1I6,2I4)' ) ja, jai, jaj
!-$$               CYCLE  AtmosI
!-$$            END IF
!-$$

            IF ( laoce (ja) ) THEN ! This point is not considered
               IF (ld_t >= 2)  WRITE ( nout, fmt ='("Atm rejected (Atm masked)",1I6,2I4)' ) ja, jai, jaj
               CYCLE  AtmosI
            END IF
            
            IF ( iamskp (ja) .EQ. 1 ) THEN  ! Periodicity point rejected
               IF ( ld_t >= 4 ) WRITE (nout, fmt ='("Atm rejected (Atm perio)",1I6,2I4)' ) ja, jai, jaj
               CYCLE AtmosI
            END IF

            IF ( yalatsup .GT. 89.9 .OR. yalatinf .LT. - 89.9 ) THEN ! Pole rejected
               IF ( ld_t >= 4 ) WRITE (nout, fmt ='("Atm rejected (Atm pole)",1I6,2I4)' ) ja, jai, jaj
               CYCLE AtmosI
            END IF

            IF ( dist_coast_a(ja) .GT. dist_max_atm ) THEN  ! Point too far from coast rejected
               IF ( ld_t >= 4 ) WRITE (nout, fmt ='("Atm rejected (Atm far from coast)",1I6,2I4)' ) ja, jai, jaj
               CYCLE AtmosI
            END IF

            IF (ld_t >= 2)  WRITE ( nout, fmt ='("Working on atm : ", 1I6,2I4,6F8.1,2I2)' ) &
               & ja, jai, jaj, xa_ed(ja,jpae), ya_ed(ja,jpae), xaloninf, xaloninf, yalatinf, yalatsup, iamskt (ja), iamskp (ja)

!-$$            IF ( xaloninf > xo_sup+dx .OR. xalonsup < xo_inf-dx ) THEN ! This point is not considered
!-$$               IF (ld_t >= 2)  WRITE ( nout, fmt ='("Atm rejected (Atm point outside oce latitude limits )",1I6,2I4,2F8.1)' ) &
!-$$                  & ja, jai, jaj, yalatinf, yalatsup 
!-$$               CYCLE  AtmosI
!-$$            END IF
!-$$            IF ( yalatinf > yo_sup+dy .OR. yalatsup < yo_inf-dy ) THEN ! This point is not considered
!-$$               IF (ld_t >= 2)  WRITE ( nout, fmt ='("rejected (Atm point outside oce longitude limits)",1I6,2I4,2F8.1)' ) &
!-$$                  &ja, jai, jaj, xaloninf, xaloninf
!-$$               CYCLE  AtmosI
!-$$            END IF
    
            !!
            OceanJ: DO joj = 1, jpoj !! Boucle sur les points oceaniques
               jo = m1o ( 1, joj) 
               OceanI: DO joi = 1, jpoi
                  jo = m1o ( joi, joj) 
                  !!
                  ! Masked point
                  IF ( iomskt (jo) .EQ. 1 .AND. .NOT. lmasko) THEN
                     IF (ld_t >= 4) WRITE (nout, fmt ='("Oce rejected (Oce masked)",2(1I6,2I4))') ja, jai, jaj, jo, joi, joj
                     IF (ld_t >= 4) WRITE (nout, fmt ='("Oce rejected (mask ) : ",2(1I6,2I4,2F8.1,1F8.4))') & 
                        & ja, jai, jaj, jo, joi, joj, xo_ed(jo,jpoe), yo_ed(jo,jpoe)
                     CYCLE OceanI
                  END IF
                  
                  ! Periodicity
                  IF (iomskp (jo) .EQ. 1 ) THEN  ! Periodicity point rejected
                     IF (ld_t >= 4) WRITE ( nout, fmt ='("Oce rejected (Oce perio) : ",2(1I6,2I4,2F8.1,1F8.4))') &
                        & ja, jai, jaj,jo, joi, joj, xo_ed(jo,jpoe), yo_ed(jo,jpoe)
                     CYCLE OceanI
                  END IF
                  !
                  !! Rejet point trop loin de la cote
                  IF ( dist_coast_o(jo) .GT. dist_max_oce ) THEN  ! Point too far from coast rejected
                     IF ( ld_t >= 4 ) WRITE (nout, fmt ='("Oce rejected (Oce far from coast)",1I6,2I4)' ) jo, joi, joj
                     CYCLE OceanI
                  END IF
                  !
                  ld_t = ld
                  !
                  !IF (ld_t <= 1) THEN
                  !   WRITE (UNIT=nout, FMT='("jo=",1I8," ")', ADVANCE='no') jo
                  !   CALL FLUSH(nout)
                  !ENDIF
                  !
                  xolonsup = MAXVAL(xo_ed(jo,:))
                  xoloninf = MINVAL(xo_ed(jo,:)) 
                  yolatsup = MAXVAL(yo_ed(jo,:))
                  yolatinf = MINVAL(yo_ed(jo,:)) 
                  IF ( yolatsup > 85.0_rl ) yolatsup = 90.0_rl
                  !IF ( joj == jpoj-1 .AND. yolatsup > 87.0_rl .AND. yalatsup > 85.0_rl) ld_t = 3

               
                  !! Geographical distance criterion
                  zg = ra * geodist (xa_ed(ja,jpae), ya_ed(ja,jpae), xo_ed(jo,jpoe), yo_ed(jo,jpoe))
                  IF ( zg .GE. dist_max_oce+dist_max_atm  ) THEN ! Boxes not close enough
                     IF (ld_t >= 4) WRITE (nout, fmt ='("Oce rejected (geodist) : ",2(1I6,2I4,2F8.1),1E14.3)') & 
                        & ja, jai, jaj, xa_ed(ja,jpae), ya_ed(ja,jpae), &
                        & jo, joi, joj, xo_ed(jo,jpoe), yo_ed(jo,jpoe), &
                        & zg
                     CYCLE OceanI
                  END IF
                  
                  IF (ld_t >= 2) WRITE ( nout, fmt ='("Oce accepted (final) : ",2(1I6,2I4,2F8.1),3(1PE13.4))') &
                     & ja, jai, jaj, xa_ed(ja,jpae), ya_ed(ja,jpae), &
                     & jo, joi, joj, xo_ed(jo,jpoe), yo_ed(jo,jpoe), &
                     & zg
            
                  !
                  
                  IF (nvo (jo) >= jpa2o ) THEN
                     WRITE (unit = nout, fmt = '("Not enough atm neighbors in : ", 2I6, 1I7, 7F8.1)' ) &
                        &  joi, joj, nvo(jo), xolont(jo), xolatt(jo), yolatinf, yolatsup, zg
                     WRITE (unit = nout, fmt = *) jai, jaj, nva(ja), xa_ed(ja,jpae), ya_ed(ja,jpae), yalatinf, yalatsup
                     WRITE (unit = nout, fmt = "('xa_ed : ', 4F10.2)" ) xa_ed(ja,:)
                     WRITE (unit = nout, fmt = *)  'ya_ed : ', ya_ed(ja,:)
                     WRITE (unit = nout, fmt = *)  'xo_ed : ', xo_ed(ja,:)
                     WRITE (unit = nout, fmt = *)  'yo_ed : ', yo_ed(ja,:)
                     STOP
                     EXIT OceanI
                  ENDIF
                  nvo (jo) = nvo (jo) + 1
                  jma2o = MAX (jma2o, nvo (jo))
                  ka2o (nvo(jo), jo) = ja
                  wa2o (nvo(jo), jo) = xasrft(ja) / xosrft(jo)

                  wasum (ja) = wasum(ja) +  wa2o (nvo(jo), jo)
                  wosum (jo) = wosum(jo) +  wa2o (nvo(jo), jo)
                  
                  !!
                  no = no + 1
                  !
               END DO OceanI
            END DO OceanJ
            nto = no + nto 
         END DO AtmosI
      END DO AtmosJ
      !!
      WRITE ( nout, fmt = *) ' '
      WRITE ( nout, fmt = '("Total points : ", 1I6 , ", Average : ", 1F9.3, " oce points per atm point" )' ) &
         & nto, REAL(nto,KIND=rl) / REAL(jpan,KIND=rl)
      !!
      
      jma2o = MAXVAL (nvo)
      jma2o = MIN (jma2o, jpa2o)
      
      !!
      WRITE (nout, fmt = *) jpa2o, jma2o, jpo2a, jmo2a
      !!
      CLOSE (unit = 36)
      CLOSE (unit = 37)
      !!
   END SUBROUTINE cotes_a
END MODULE mod_cotes_a
