! -*- Mode: f90 -*-
PROGRAM cotes_etal
   USE declare
   USE modeles
   USE mod_lecdata
   USE formula
   USE math
   USE mod_cotes_a
   USE mod_rectifie
   USE mod_lbc
   USE mod_norma
   USE bords
   USE mod_inter
   USE mod_prih
   USE mod_wri_wei
   USE mod_inipar
   USE fliocom
   USE getincom
   USE errioipsl
!!!
   IMPLICIT NONE
!!!
!!!   A partir d'un fichier de poids, complete avec les rivieres et
!!!   les poids pour le run off
   !! On met a zero les poids sur les points non cotiers, et on renormalise
   !!
   INTEGER (kind=il), PARAMETER :: jpr = 52 ! Nombre de rivieres
   REAL (kind=rl) :: zsuma, zsumo
   REAL (kind=rl), DIMENSION (:), ALLOCATABLE :: za
   REAL (kind=rl), DIMENSION (:), ALLOCATABLE :: zo
   !!
   CHARACTER (LEN = 1) :: clriv
   CHARACTER (LEN = 30) :: clname
   INTEGER (kind=il) :: ja, jo, jo2, jo3, jn, jno, joi, joj, jai, jaj, jr, kn  ! indices de boucle
   INTEGER (kind=il) :: jai_p, jai_m, jaj_p, jaj_m, n1
   INTEGER (kind=il) :: joi_p, joi_m, joj_p, joj_m
   REAL (kind=rl) :: z_d_1, z_d_2, zzmin
   INTEGER (kind=il) :: nriv = 32, nlmd = 35
   INTEGER (kind=il), DIMENSION (:, :), ALLOCATABLE :: jx ! Point trouve sous une maille atm
   INTEGER (kind=il) :: kom, ko, niter, nc
   LOGICAL, DIMENSION (:), ALLOCATABLE :: la_temp, lo_temp
   REAL    (kind=rl), DIMENSION (:), ALLOCATABLE :: wtemp
   INTEGER (kind=il), DIMENSION (:), ALLOCATABLE :: ktemp
   INTEGER (kind=il), DIMENSION (:,:), ALLOCATABLE :: ktemp2
   REAL(kind=rl), DIMENSION (:,:), ALLOCATABLE  :: wtemp2
   !INTEGER (kind=il), DIMENSION (:), ALLOCATABLE  :: iamsk
   !INTEGER (kind=il), DIMENSION (:), ALLOCATABLE  :: iomsk
   INTEGER (kind=il) :: jovoid, jot, inum
   CHARACTER (len=80) :: cfname4, cfname8
   LOGICAL :: ltrouve, ltrouve2
   INTEGER (kind=il), DIMENSION (:), ALLOCATABLE :: itarget, idest
   REAL    (kind=rl), DIMENSION (:), ALLOCATABLE :: wtarget, wdest
   INTEGER (kind=il), DIMENSION (:,:), ALLOCATABLE :: i2a, i2o
   INTEGER (kind=il) :: no, ntrouve
   INTEGER (kind=il), DIMENSION (:), ALLOCATABLE :: jo_n
   LOGICAL :: l_fulldiag = .TRUE.
   CHARACTER (len=180) :: c_date, c_time, c_zone, c_tmp
   CHARACTER (len=80) :: clarg
   INTEGER :: narg
   REAL(kind=rl), DIMENSION (:), ALLOCATABLE :: tmask_atl, tmask_noclose, tmask_nomed, tmask_med
   REAL(kind=rl), DIMENSION (:, :), ALLOCATABLE  :: z2o
   CHARACTER (len=40) :: cl_bassin
   INTEGER (kind=il) :: il_ncid
   !!
   INTEGER (kind=il), DIMENSION (2) :: jind
   INTEGER (kind=il) :: ierr
   !!
   INTEGER :: nid_it, nid_id
   !!
   CHARACTER (len = 50) :: cldiag_a2o, clw_a2o, clw_a2o_cdf, clw_a2o_mct
   CHARACTER (len = 25) :: mo_name, a2o_name
   CHARACTER (len =  1) :: c_i, c_r

   !! Lecture de la ligne de comande
   narg = iargc()
   IF ( narg > 0 ) THEN
      CALL getarg ( 1, clarg)
      SELECT CASE (TRIM(clarg))
      CASE Default
         IF ( INDEX ( TRIM(clarg), '.def' ) /= 0 ) THEN
            WRITE (nout,*) 'Lecture des parametres dans ', TRIM(clarg)
            CALL getin_name ( TRIM (clarg) )
         ELSE
            WRITE (nout,*) 'Lecture des parametres dans run.def'
         ENDIF
      END SELECT
   END IF
   !!
   CALL inipar
   CALL alloc_modeles

   !!
   ALLOCATE (za      (jpan)      , STAT=ierr) ; CALL chk_allo (ierr, 'za', lreset=.TRUE., crout='cotes')
   ALLOCATE (zo      (jpon)      , STAT=ierr) ; CALL chk_allo (ierr, 'zo')
   ALLOCATE (jx      (jpa2o,2)   , STAT=ierr) ; CALL chk_allo (ierr, 'jx')
   !
   ALLOCATE (lacot   (jpan)      , STAT=ierr) ; CALL chk_allo (ierr, 'lacot')  ; lacot  = .FALSE.
   ALLOCATE (laland  (jpan)      , STAT=ierr) ; CALL chk_allo (ierr, 'laland') ; laland = .FALSE.
   ALLOCATE (laoce   (jpan)      , STAT=ierr) ; CALL chk_allo (ierr, 'laoce')  ; laoce  = .FALSE.
   !
   ALLOCATE (locot   (jpon)      , STAT=ierr) ; CALL chk_allo (ierr, 'locot')  ; locot  = .FALSE.
   ALLOCATE (looce   (jpon)      , STAT=ierr) ; CALL chk_allo (ierr, 'looce')  ; looce  = .FALSE.
   ALLOCATE (lo_nearcoast(jpon)  , STAT=ierr) ; CALL chk_allo (ierr, 'lonearcoast')  ; looce  = .FALSE.
   ALLOCATE (la_nearcoast(jpan)  , STAT=ierr) ; CALL chk_allo (ierr, 'lanearcoast')  ; looce  = .FALSE.
   !
   ALLOCATE (ktemp   (jpa2o)     , STAT=ierr) ; CALL chk_allo (ierr, 'ktemp')
   ALLOCATE (wtemp   (jpa2o)     , STAT=ierr) ; CALL chk_allo (ierr, 'wtemp')
   ALLOCATE (dist_coast_o (jpon) , STAT=ierr) ; CALL chk_allo (ierr, 'dist_coast_o')
   ALLOCATE (dist_coast_a (jpan) , STAT=ierr) ; CALL chk_allo (ierr, 'dist_coast_a')
   !
   ALLOCATE (itarget (jpan)      , STAT=ierr) ; CALL chk_allo (ierr, 'itarget')
   ALLOCATE (wtarget (jpan)      , STAT=ierr) ; CALL chk_allo (ierr, 'wtarget')
   ALLOCATE (i2a     (jpai, jpaj), STAT=ierr) ; CALL chk_allo (ierr, 'i2a')
   !
   ALLOCATE (idest   (jpon)      , STAT=ierr) ; CALL chk_allo (ierr, 'idest')
   ALLOCATE (wdest   (jpon)      , STAT=ierr) ; CALL chk_allo (ierr, 'wdest')
   ALLOCATE (i2o     (jpoi, jpoj), STAT=ierr) ; CALL chk_allo (ierr, 'i2o')
   !
   ALLOCATE (tmask_atl     (jpon), STAT=ierr) ; CALL chk_allo (ierr, 'tmask_atl')
   ALLOCATE (tmask_noclose (jpon), STAT=ierr) ; CALL chk_allo (ierr, 'tmask_noclose')
   ALLOCATE (tmask_nomed   (jpon), STAT=ierr) ; CALL chk_allo (ierr, 'tmasl_nomed')
   ALLOCATE (tmask_med     (jpon), STAT=ierr) ; CALL chk_allo (ierr, 'tmask_med')
   ALLOCATE (z2o (jpoi, jpoj), STAT=ierr)     ; CALL chk_allo (ierr, 'z2o')
   !
   IF (l_limit_iosize) l_fulldiag = .FALSE.
   !!
   !! Initialisation
   ngrd = 11 ; nsrf = 12 ; nmsk = 13 ; nchk = 14 ; ndeb = 9 ; nbug1 = 10
   nwei4o2a = 81 ; nwei8o2a = 82 ; nwei4a2o = 83 ; nwei8a2o = 84
   !
   nout = 6
   IF (nout /= 6 .AND. nout /= 0 ) &
      & OPEN (unit = nout, file = 'cote' // TRIM(c_suffix) // '.out', action = 'WRITE', status = 'unknown', position = 'REWIND' )
   !!
   !! Diagnostics files
   !!
   IF (nout /= 6 ) &
      &  OPEN (unit = nout, file = 'cotes' // TRIM(c_suffix) // '.out', position = 'REWIND', action = 'WRITE', status = 'replace' )
   !!
   !! Read coordinates of all models, and weights
   !!
   CALL lecdata (lecweights = .FALSE., leco2amask = .TRUE. )

   !! Lecture masques de bassin
   IF ( TRIM (cotyp) == 'orca4' .OR. &
      & TRIM (cotyp) == 'orca2' .OR. TRIM (cotyp) == 'orca2.0' .OR. TRIM (cotyp) == 'orca2.1' .OR. TRIM (cotyp) == 'orca2.3' .OR. &
      & TRIM (cotyp) == 'orca1' &
      & ) THEN 
      !cl_bassin = TRIM (cotyp) 
      cl_bassin = TRIM(c_basins)
!-$$      IF (c_period /= 'none' ) cl_bassin = TRIM (cl_bassin) // TRIM (c_period)
      WRITE (nout,*) 'Reading bassin masks in : ', TRIM (cl_bassin)
      CALL flioopfd (TRIM (cl_bassin), il_ncid )
      CALL fliogetv (il_ncid, 'mask_atl'    , z2o )
      tmask_atl = RESHAPE (z2o, (/ jpon /) )
      CALL fliogetv (il_ncid, 'mask_noclose', z2o )
      tmask_noclose = RESHAPE (z2o, (/ jpon /) )
      CALL fliogetv (il_ncid, 'mask_nomed'  , z2o )
      tmask_nomed = RESHAPE (z2o, (/ jpon /) )
      CALL flioclo (il_ncid)
   ELSE
      tmask_atl     = REAL (1-iomskt, rl)
      tmask_noclose = REAL (1-iomskt, rl)
      tmask_nomed   = REAL (1-iomskt, rl)
   END IF
   !
   WRITE (unit=nout, fmt=*) 'iomskt'
   CALL prihin (RESHAPE(iomskt             ,(/jpoi,jpoj/)), 1_il, nout)
   WRITE (unit=nout, fmt=*) 'tmask_atl'
   CALL prihin (RESHAPE(NINT(tmask_atl)    ,(/jpoi,jpoj/)), 1_il, nout)
   WRITE (unit=nout, fmt=*) 'tmask_med'
   !CALL prihin (RESHAPE(NINT(tmask_med)    ,(/jpoi,jpoj/)), 1_il, nout)
   WRITE (unit=nout, fmt=*) 'tmask_noclose'
   !CALL prihin (RESHAPE(NINT(tmask_noclose),(/jpoi,jpoj/)), 1_il, nout)
   !
   WRITE (nout,*) "iamskt"
   iamskt = 0
   WHERE (o2amask .LT. epsfrac) iamskt = 1
   CALL prihin (RESHAPE(iamskt,(/jpai,jpaj/)), 1, nout)
   
   ! Set correct periodicity to grids
   CALL lbc (xolont, noperio, 'T', jpoi, jpoj)
   CALL lbc (xolonu, noperio, 'U', jpoi, jpoj)
   CALL lbc (xolonv, noperio, 'V', jpoi, jpoj)
   CALL lbc (xolonf, noperio, 'F', jpoi, jpoj)
   CALL lbc (xolatt, noperio, 'T', jpoi, jpoj)
   CALL lbc (xolatu, noperio, 'U', jpoi, jpoj)
   CALL lbc (xolatv, noperio, 'V', jpoi, jpoj)
   CALL lbc (xolatf, noperio, 'F', jpoi, jpoj)
   CALL lbc (xosrft, noperio, 'T', jpoi, jpoj)
   CALL lbc (iomskt, noperio, 'T', jpoi, jpoj)
   !
   CALL lbc (xalont, naperio, 'T', jpai, jpaj)
   CALL lbc (xalonu, naperio, 'U', jpai, jpaj)
   CALL lbc (xalonv, naperio, 'V', jpai, jpaj)
   CALL lbc (xalatt, naperio, 'T', jpai, jpaj)
   CALL lbc (xalatu, naperio, 'U', jpai, jpaj)
   CALL lbc (xalatv, naperio, 'V', jpai, jpaj)
   CALL lbc (xasrft, naperio, 'T', jpai, jpaj)
   CALL lbc (iamskt, naperio, 'T', jpai, jpaj)
   !!
   CALL rectifie
   !!
   CALL fliocrfd ('itarget' // TRIM(c_suffix), (/'x', 'y'/), (/jpai, jpaj/), nid_it, mode='REPLACE')
   CALL flioputa (nid_it, "?", "title"         , "itarget" )
   CALL flioputa (nid_it, '?', 'Comment', TRIM(c_comment) )
   CALL DATE_AND_TIME (c_date, c_time, c_zone )
   CALL flioputa (nid_it, "?", "history"       , "Created: "//c_date(1:4)//"-"//c_date(5:6)//"-"// &
      & c_date(7:8)//" "//c_time(1:2)//"h"//c_time(3:4)//" GMT"//TRIM(c_zone) )
   CALL flioputa (nid_it, "?", "method"        , "MOSAIC" )
   CALL flioputa (nid_it, "?", "source_grid"   , "curvilinear" )
   CALL flioputa (nid_it, "?", "dest_grid"     , "curvilinear" )
   CALL flioputa (nid_it, "?", "Institution"   , "IPSL" )
   CALL flioputa (nid_it, "?", "Model"         , "IPSL CM6" )
   CALL GET_ENVIRONMENT_VARIABLE ( NAME="HOSTNAME", VALUE=c_tmp, TRIM_NAME=.TRUE., STATUS=ierr)
   IF ( ierr == 0 ) THEN
      CALL flioputa (nid_it, "?", "HOSTNAME"     , TRIM(c_tmp) )
   ELSE 
      WRITE (nout,*) 'Environment variable not found : $HOSTNAME'
   END IF
   CALL GET_ENVIRONMENT_VARIABLE ( NAME="LOGNAME" , VALUE=c_tmp, TRIM_NAME=.TRUE., STATUS=ierr)
   IF ( ierr == 0 ) THEN
      CALL flioputa (nid_it, "?", "LOGNAME"      , TRIM(c_tmp) )
   ELSE 
      WRITE (nout,*) 'Environment variable not found : $LOGNAME'
   END IF

   CALL fliodefv (nid_it, 'laland'      , (/1,2/), v_t=flio_i4)
   CALL fliodefv (nid_it, 'lacot'       , (/1,2/), v_t=flio_i4)
   CALL fliodefv (nid_it, 'laoce'       , (/1,2/), v_t=flio_i4)
   CALL fliodefv (nid_it, 'la_nearcoast' , (/1,2/), v_t=flio_i4)
   CALL fliodefv (nid_it, 'dist_coast_a' , (/1,2/), v_t=flio_r4)
   
   CALL fliodefv (nid_it, 'lon', (/1, 2/), units="degree_north", v_t=flio_r4 )
   CALL fliodefv (nid_it, 'lat', (/1, 2/), units="degree_east",  v_t=flio_r4 )
   CALL fliodefv (nid_it, 'o2amask', (/1,2/), v_t=flio_r4)
   CALL fliodefv (nid_it, 'iamskt', (/1,2/), v_t=flio_i4)
   CALL fliodefv (nid_it, 'iamskp', (/1,2/), v_t=flio_i4)

   CALL flioputv (nid_it, 'lon'    , RESHAPE ( xalont, (/jpai, jpaj/)) )
   CALL flioputv (nid_it, 'lat'    , RESHAPE ( xalatt, (/jpai, jpaj/)) )
   CALL flioputv (nid_it, 'o2amask', RESHAPE (o2amask, (/jpai, jpaj/)) )
   CALL flioputv (nid_it, 'iamskt' , RESHAPE (iamskt , (/jpai, jpaj/)) )
   CALL flioputv (nid_it, 'iamskp' , RESHAPE (iamskp , (/jpai, jpaj/)) )
   !!

   !!
   CALL fliocrfd ('idest' // TRIM(c_suffix), (/'x', 'y'/), (/jpoi, jpoj/), nid_id, mode='REPLACE')
   CALL flioputa (nid_id, "?", "title"         , "idest" )
   CALL flioputa (nid_id, '?', 'Comment', TRIM(c_comment) )
   CALL DATE_AND_TIME (c_date, c_time, c_zone )
   CALL flioputa (nid_id, "?", "history"       , "Created: "//c_date(1:4)//"-"//c_date(5:6)//"-"// &
      & c_date(7:8)//" "//c_time(1:2)//"h"//c_time(3:4)//" GMT"//TRIM(c_zone) )
   CALL flioputa (nid_id, "?", "method"        , "MOSAIC" )
   CALL flioputa (nid_id, "?", "source_grid"   , "curvilinear" )
   CALL flioputa (nid_id, "?", "dest_grid"     , "curvilinear" )
   CALL flioputa (nid_id, "?", "Institution"   , "IPSL" )
   CALL flioputa (nid_id, "?", "Model"         , "IPSL CM6" )
   CALL GET_ENVIRONMENT_VARIABLE ( NAME="HOSTNAME", VALUE=c_tmp, TRIM_NAME=.TRUE., STATUS=ierr)
   IF ( ierr == 0 ) THEN
      CALL flioputa (nid_id, "?", "HOSTNAME"     , TRIM(c_tmp) )
   ELSE 
      WRITE (nout,*) 'Environment variable not found : $HOSTNAME'
   END IF
   CALL GET_ENVIRONMENT_VARIABLE ( NAME="LOGNAME" , VALUE=c_tmp, TRIM_NAME=.TRUE., STATUS=ierr)
   IF ( ierr == 0 ) THEN
      CALL flioputa (nid_id, "?", "LOGNAME"      , TRIM(c_tmp) )
   ELSE 
      WRITE (nout,*) 'Environment variable not found : $LOGNAME'
   END IF

   CALL fliodefv (nid_id, 'locot'       , (/1,2/), v_t=flio_i4)
   CALL fliodefv (nid_id, 'looce'       , (/1,2/), v_t=flio_i4)
   CALL fliodefv (nid_id, 'lo_nearcoast' , (/1,2/), v_t=flio_i4)
   CALL fliodefv (nid_id, 'dist_coast_o' , (/1,2/), v_t=flio_r4)
   
   CALL fliodefv (nid_id, 'lon', (/1, 2/), units="degree_north", v_t=flio_r4 )
   CALL fliodefv (nid_id, 'lat', (/1, 2/), units="degree_east",  v_t=flio_r4 )
   CALL fliodefv (nid_id, 'iomskt', (/1,2/), v_t=flio_i4)
   CALL fliodefv (nid_id, 'iomskp', (/1,2/), v_t=flio_i4)

   CALL flioputv (nid_id, 'lon'    , RESHAPE ( xolont, (/jpoi, jpoj/)) )
   CALL flioputv (nid_id, 'lat'    , RESHAPE ( xolatt, (/jpoi, jpoj/)) )
   CALL flioputv (nid_id, 'iomskt' , RESHAPE (iamskt , (/jpoi, jpoj/)) )
   CALL flioputv (nid_id, 'iomskp' , RESHAPE (iamskp , (/jpoi, jpoj/)) )
  
   !!
   !! Compute edges of grid boxes
   !!
   CALL bord_a
   CALL bord_o
   CALL bord_oa
   !!
   mo_name  = "mozaic"
   a2o_name = "a2o"
   !!
   WRITE (nout,*) 'Calculs points terre/oce/cote sur grille atmosphere'
   WHERE (o2amask .LT. epsfrac                                     ) laland = .TRUE.
   WHERE (o2amask .GE. epsfrac .AND. o2amask .LE. (1.0_rl-epsfrac) ) lacot  = .TRUE.
   WHERE (                           o2amask .GT. (1.0_rl-epsfrac) ) laoce  = .TRUE.
   !!
   WRITE (UNIT=nout, FMT=*) 'Points cotiers ', COUNT(lacot)
   WRITE (nout,*) 'lacot '
   CALL prihbo (RESHAPE(lacot, (/jpai, jpaj/)), nout, l_norsud=.FALSE.)
   
   WRITE (nout,*) 'Ecriture '
   i2a = 0
   WHERE (RESHAPE(laland,(/jpai,jpaj/))) i2a=1
   CALL flioputv (nid_it, "laland", i2a)
   i2a = 0
   WHERE (RESHAPE(laoce ,(/jpai,jpaj/))) i2a=1
   CALL flioputv (nid_it, "laoce", i2a)
   i2a = 0
   WHERE (RESHAPE(lacot ,(/jpai,jpaj/))) i2a=1
   CALL flioputv (nid_it, "lacot", i2a)
   !!
   WRITE (nout,*) 'Determination des points cotes ocean '
   locot = .FALSE.
   looce = .FALSE.
   DO jo = 1, jpon
      IF ( iomskt (jo) == 0_il .AND. iomskp (jo) == 0_il ) THEN
         joi = moi (jo) ; joj = moj (jo) ! Indices 2D
         joi_p = MIN(joi+1, jpoi) ; joi_m = MAX (joi-1, 1)
         joj_p = MIN(joj+1, jpoj) ; joj_m = MAX (joj-1, 1)
         IF (    iomskt (m1o (joi_p, joj  )) == 1  &
            .OR. iomskt (m1o (joi_m, joj  )) == 1  &
            .OR. iomskt (m1o (joi  , joj_p)) == 1  &
            .OR. iomskt (m1o (joi  , joj_m)) == 1  &
            .OR. iomskt (m1o (joi_p, joj_p)) == 1  &
            .OR. iomskt (m1o (joi_p, joj_m)) == 1  &
            .OR. iomskt (m1o (joi_m, joj_p)) == 1  &
            .OR. iomskt (m1o (joi_m, joj_m)) == 1  ) THEN
            locot (jo) = .TRUE.
         ELSE 
            looce (jo) = .TRUE.
         END IF
      END IF
   END DO
   CALL lbc (locot, noperio, 'T', jpoi, jpoj)
   CALL lbc (looce, noperio, 'T', jpoi, jpoj)

   i2o = 0
   WHERE (RESHAPE(locot,(/jpoi,jpoj/))) i2o=1
   CALL flioputv (nid_id, "locot", i2o)
   i2o = 0
   WHERE (RESHAPE(looce,(/jpoi,jpoj/))) i2o=1
   CALL flioputv (nid_id, "looce", i2o)
   
   WRITE (nout,*) 'locot '
   CALL prihbo (RESHAPE(locot, (/jpoi, jpoj/)), nout, l_norsud=.FALSE.)

   !!
   !! Determination d'une bande cotiere atm
   la_nearcoast = lacot
   ALLOCATE (la_temp(jpan), STAT=ierr) ; CALL chk_allo (ierr, 'la_temp')
   DO niter = 1, 5
      la_temp = la_nearcoast
      DO ja = 1, jpan
         IF ( iamskt(ja) == 1_il .AND. iamskp (ja) == 0_il ) THEN
            jai = mai (ja) ; jaj = maj (ja) ! Indices 2D
            jai_p = MIN(jai+1, jpai) ; jai_m = MAX (jai-1, 1)
            jaj_p = MIN(jaj+1, jpaj) ; jaj_m = MAX (jaj-1, 1)
            IF (    la_temp (m1a (jai_p, jaj  ))  &
               .OR. la_temp (m1a (jai_m, jaj  ))  &
               .OR. la_temp (m1a (jai  , jaj_p))  &
               .OR. la_temp (m1a (jai  , jaj_m))  &
               .OR. la_temp (m1a (jai_p, jaj_p))  &
               .OR. la_temp (m1a (jai_p, jaj_m))  &
               .OR. la_temp (m1a (jai_m, jaj_p))  &
               .OR. la_temp (m1a (jai_m, jaj_m))  ) THEN
               la_nearcoast (ja) = .TRUE.
            END IF
         END IF
      END DO
      CALL lbc (la_nearcoast, naperio, 'T', jpai, jpaj)
   END DO

   WRITE (nout,*) 'la_nearcoast '
   CALL prihbo (RESHAPE(la_nearcoast, (/jpai, jpaj/)), nout, l_norsud=.TRUE.)
   i2a = 0
   WHERE (RESHAPE(la_nearcoast ,(/jpai,jpaj/))) i2a=1
   CALL flioputv (nid_it, "la_nearcoast", i2a)
   
   !!
   !! Determination d'une bande cotiere ocean
   lo_nearcoast = locot
   ALLOCATE (lo_temp(jpon), STAT=ierr) ; CALL chk_allo (ierr, 'lo_temp')
   DO niter = 1, 8
      lo_temp = lo_nearcoast
      DO jo = 1, jpon
         IF ( iomskt(jo) == 0 .AND. iomskp (jo) == 0_il ) THEN
            joi = moi (jo) ; joj = moj (jo) ! Indices 2D
            joi_p = MIN(joi+1, jpoi) ; joi_m = MAX(joi-1, 1)
            joj_p = MIN(joj+1, jpoj) ; joj_m = MAX(joj-1, 1)
            IF (    lo_temp (m1o (joi_p, joj  ))  &
               .OR. lo_temp (m1o (joi_m, joj  ))  &
               .OR. lo_temp (m1o (joi  , joj_p))  &
               .OR. lo_temp (m1o (joi  , joj_m))  &
               .OR. lo_temp (m1o (joi_p, joj_p))  &
               .OR. lo_temp (m1o (joi_p, joj_m))  &
               .OR. lo_temp (m1o (joi_m, joj_p))  &
               .OR. lo_temp (m1o (joi_m, joj_m))  ) THEN
               lo_nearcoast (jo) = .TRUE.
            END IF
         END IF
      END DO
      CALL lbc (lo_nearcoast, noperio, 'T', jpoi, jpoj)
   END DO

   WRITE (nout,*) 'lo_nearcoast '
   CALL prihbo (RESHAPE(lo_nearcoast, (/jpoi, jpoj/)), nout, l_norsud=.FALSE.)
   i2o = 0
   WHERE (RESHAPE(lo_nearcoast ,(/jpoi,jpoj/))) i2o=1
   CALL flioputv (nid_id, "lo_nearcoast", i2o)
   
   !!
   WRITE (nout,*) 'Distance a la cote - points atmosphere'
   DO ja = 1, jpan
      dist_coast_a (ja) = rpi * ra
      IF ( MOD(ja, 1000) .EQ. 0 ) WRITE (nout,*) ja, '/', jpan
      IF ( iamskt (ja) .EQ. 0 ) THEN
         dist_coast_a (ja) = 0.0E0_rl
         CYCLE
      END IF
      IF ( .NOT. la_nearcoast (ja) ) THEN
         dist_coast_a (ja) = 2.0_rl * dist_max_atm
         CYCLE
      END IF
      DO jo = 1, jpon
         IF ( locot(jo) ) THEN
            dist_coast_a (ja) = MIN ( dist_coast_a (ja), &
               & ra * geodist ( xalont(ja), xalatt(ja), xolont(jo), xolatt(jo) ) )
         END IF
      END DO
   END DO
   CALL lbc ( dist_coast_a, naperio, 'T', jpai, jpaj )
   CALL prihre (RESHAPE(dist_coast_a, (/jpai,jpaj/)), 1.0E-4, nout, l_norsud=.TRUE.)

   CALL flioputv (nid_it, "dist_coast_a", RESHAPE(dist_coast_a, (/jpai,jpaj/)))
   !!
   WRITE (nout,*) 'Distance a la cote - point ocean'
   DO jo = 1, jpon
      IF ( MOD(jo, 5000) .EQ. 0 ) WRITE (nout,*) jo, '/', jpon
      dist_coast_o (jo) =  rpi * ra
      IF ( iomskt (jo) .EQ. 1 ) THEN
         dist_coast_o (jo) = 0.0E0_rl
         CYCLE
      END IF
      IF ( .NOT. lo_nearcoast (jo) ) THEN
         dist_coast_o (jo) = 2.0_rl * dist_max_oce
         CYCLE
      END IF
      
      DO jo2 = 1, jpon
         IF (  locot(jo2) ) THEN
            dist_coast_o (jo) = MIN ( dist_coast_o (jo), &
               & ra * geodist ( xolont(jo), xolatt(jo), xolont(jo2), xolatt(jo2) ) )
         END IF
      END DO
   END DO
   CALL lbc ( dist_coast_a, naperio, 'T', jpoi, jpoj )
   CALL prihre (RESHAPE(dist_coast_o, (/jpoi,jpoj/)), 1.0E-4, nout)

   CALL flioputv (nid_id, "dist_coast_o", RESHAPE(dist_coast_o, (/jpoi,jpoj/)))
   
   WRITE (nout,*) 'Verif coherence (tout doit etre nul)'
   WRITE (nout,*) COUNT ( laland .AND. lacot)
   WRITE (nout,*) COUNT ( lacot  .AND. laoce)
   WRITE (nout,*) COUNT ( laoce  .AND. laland)
   WRITE (nout,*) COUNT ( .NOT. ( laland .OR. lacot .OR. laoce) )



   !!
   WRITE (unit = nout, fmt = *) 'Nombre de points cotes atmosphere : ', COUNT (lacot)
   WRITE (unit = nout, fmt = *) 'Nombre de points cotes ocean      : ', COUNT (locot)
   !!
   CALL bilan ("Avec cote ", c_case="complet", c_int_atm="Integral", c_int_oce="Integral")
   CALL bilan ("Avec cote ", c_case="ocean"  , c_int_atm="Integral", c_int_oce="Integral")
   CALL bilan ("Avec cote ", c_case="cote"   , c_int_atm="Integral", c_int_oce="Integral")


   E_DRYRUN: IF (l_dryrun) THEN
      WRITE (nout,*) "Remplissage bidon des champs pour tester les I/O"
      jma2o = jma2or
      nvo = jma2or
      WRITE (nout,*) 'jma2o pour test : ', jma2o
      CALL RANDOM_SEED
      CALL RANDOM_NUMBER (wa2o) ; ka2o = NINT (wa2o*REAL(jpan,rl) )
      
      DO jo = 1, jpon
         IF ( iomskt (jo) == 1 ) THEN
            wa2o (:, jo) = 0.0_rl
            ka2o (:, jo) = 0_il
         END IF
      END DO
      
      DO jo = 1, jpon
         DO jno = 1, jpa2o
            ja = ka2o (jno, jo)
            IF (ja > 0) THEN 
               IF (iamskt (ja) == 1) THEN
                  wa2o (jno, jo) = 0.0_rl ; ka2o (jno, jo) = 0_il
               END IF
            END IF
         END DO
      END DO
   ELSE
      
      CALL cotes_a

      WRITE (nout, *) 'Renormalization'
!-$$      RenormA : DO ja = 1, jpan
!-$$         z_d_1 = 0.0e0_rl
!-$$         kom = 0
!-$$         RenormO : DO jo = 1, jpon
!-$$            DO jn = 1, jpa2o
!-$$               IF ( ka2o (jn,jo) == ja ) THEN
!-$$                  z_d_1 = z_d_1 + wa2o (jn,jo) 
!-$$                  kom = kom + 1
!-$$                  jx (kom,:) = (/ jn, jo /)
!-$$                  !!$ WRITE (unit = nout, fmt = '(6I6,16F18.6) ') ja, jo, jn, kom, jx (kom, :), &
!-$$                  !!$   wa2o (jn,jo), wa2o (jx (kom, 1), jx (kom, 2)), z_d_1, &
!-$$                  !!$   xosrft (jo), xasrft (ja)
!-$$               END IF
!-$$            END DO
!-$$         ENDDO RenormO
!-$$         IF (kom /= 0 ) THEN
!-$$            IF ( z_d_1 == 0.0_rl ) THEN
!-$$               WRITE (nout, *) 'z_d_1 nul ', ja, xasrft (ja), lacot (ja), iamskt (ja), &
!-$$                  & wa2o (:,ja), ka2o (:,ja)
!-$$               STOP
!-$$            ELSE
!-$$               DO ko = 1, kom
!-$$                  wa2o (jx (ko,1), jx (ko,2)) = wa2o (jx (ko,1), jx (ko,2)) / z_d_1
!-$$               END DO
!-$$            ENDIF
!-$$         END IF
!-$$      ENDDO RenormA
      wasum = 0.0_rl
      DO jo = 1, jpon
         IF ( nvo(jo) /= 0) THEN
            DO jn = 1, nvo(jo)
               ja = ka2o (jn,jo)
               wasum (ja) = wasum (ja) + wa2o (jn,jo)
            END DO
         END IF
      END DO
      !!
      DO jo = 1, jpon
         IF ( nvo(jo) /= 0 ) THEN
            DO jn = 1, nvo(jo)
               ja = ka2o (jn,jo)
               IF ( wasum (ja) /= 0.0_rl ) wa2o (jn,jo) = wa2o (jn,jo) / wasum (ja) 
            END DO
         END IF
      END DO

      !!
      CALL int_wei
      !!
      !! Controle
      !! 
      CALL verif (' Normalisation')
      !!
      CALL bilan ("Final ", c_case="terre"   , c_int_atm="Integral", c_int_oce="Local")
      CALL bilan ("Final ", c_case="terre100", c_int_atm="Integral", c_int_oce="Local")
      CALL bilan ("Final ", c_case="cote"    , c_int_atm="Integral", c_int_oce="Local")
      !!
      WRITE (unit = nout, fmt = * ) 'Nombre de voisins : ', jma2o
      !!
      CALL gather_wei ('apres normalisation')
      CALL verif ('apres gather' )

      !! Atm mask interpolated to oce
      za = REAL (1_il-iamskt, KIND = rl )
      CALL inter_a2o (za, a2omask )
      !! 1 on Atm interpolated to oce
      za = REAL (1_il       , KIND = rl )
      CALL inter_a2o (za, a2ofull )

      !!
      !! Checking weights
      WRITE (unit = nout, fmt = '("Neighbors a2o     : ", 3I9  )' ) &
         &  MINVAL (nvo, nvo /=0), MAXVAL (nvo), jma2o
      WRITE (unit = nout, fmt = '("Index a2o         : ", 2I9  )' ) &
         &  MINVAL (ka2o, ka2o /= 0), MAXVAL (ka2o)
      jind = MINLOC(wa2o, wa2o /= 0.0_rl) ; jo = jind(2) ; jn = jind(1)
      joi = m2oi(jo)  ;  joj = m2oj(jo)
      WRITE (unit = nout, fmt = '("Weights a2o mini : ", 4I6, 1E13.4, 3I6)' ) &
         & jo, jn, joi, joj, wa2o(jn,jo), ka2o(jn,jo), m2ai(ka2o(jn,jo)), m2aj(ka2o(jn,jo))
      jind = MAXLOC(wa2o, wa2o /= 0.0_rl) ; jo = jind(2) ; jn = jind(1)
      joi = m2oi(jo) ; joj = m2oj(jo)
      WRITE (unit = nout, fmt = '("Weights a2o maxi : ", 4I6, 1E13.4, 3I6)' ) &
         & jo, jn, joi, joj, wa2o(jn,jo), ka2o(jn,jo), m2ai(ka2o(jn,jo)), m2aj(ka2o(jn,jo))
      !
      jind(1:1) = INT(MAXLOC (nvo),il) ; jo = jind(1)
      WRITE (unit = nout, fmt = *) jo, m2oi(jo), m2oj(jo), ka2o(1:nvo(jo),jo), &
         & (m2ai(ka2o(jn,jo)), m2aj(ka2o(jn,jo)), jn = 1, nvo(jo))
      !!
      clweight =  "WEIGHTS4" ; cladress = "ADRESSE4"
      WRITE (unit = nout, fmt = *) cladress, " ", clweight, " ", jpa2o, jma2o
      !!
      !! Controle
      !! 
      WRITE (nout, *) 'Verif avant ecriture'
      WRITE (nout, *) 'wa2o ', MINVAL (wa2o), MAXVAL (wa2o), COUNT (wa2o > 0.0_rl)
      WRITE (nout, *) 'ka2o ', MINVAL (ka2o), MAXVAL (ka2o), COUNT (ka2o > 0 )
      WRITE (nout, *) 'xasrft ', MINVAL (xasrft), MAXVAL (xasrft)
      WRITE (nout, *) 'o2amask ', MINVAL (o2amask), MAXVAL (o2amask), SUM (o2amask)
      WRITE (nout, *) 'xosrft ', MINVAL (xosrft), MAXVAL (xosrft)
      WRITE (nout, *) 'iomskt ', MINVAL (iomskt), MAXVAL (iomskt), COUNT (iomskt == 0)
      WRITE (nout, *) 'iomskp ', MINVAL (iomskp), MAXVAL (iomskp), COUNT (iomskp == 0)
      WRITE (nout, *) 'iamskt ', MINVAL (iamskt), MAXVAL (iamskt), COUNT (iamskt == 0)
      WRITE (nout, *) 'locot ', COUNT (locot)
      !!
      !!
   END IF E_DRYRUN
   !!
   !!
   WRITE (nout, *) ' '
   WRITE (nout, *) ' '
   WRITE (nout, *) 'Eventuels traitement specifiques'
   WRITE (nout, *) ' '
   WRITE (nout, *) ' '


   !! Extension ??

   !! Traitements specifiques, tres specifiques ... !!
   IF ( TRIM(c_suffix) == "_runoffNord09" ) THEN
      WRITE (nout, *) 'Traitement specifique _runoffNord09'
      DO jo = 1, jpon
         IF ( tmask_atl(jo) == 1 .AND. xolatt(jo) > 40.0_rl ) wa2o(:,jo) = wa2o(:,jo) * 0.9
      END DO
   END IF
   !
   IF ( TRIM(c_suffix) == "_runoffNord07" ) THEN
      WRITE (nout, *) 'Traitement specifique _runoffNord07'
      DO jo = 1, jpon
         IF ( tmask_atl(jo) == 1 .AND. xolatt(jo) > 40.0_rl ) wa2o(:,jo) = wa2o(:,jo) * 0.7
      END DO
   END IF

   IF ( TRIM(c_suffix) == "_runoffNord00" ) THEN
      WRITE (nout, *) 'Traitement specifique _runoffNord00'
      DO jo = 1, jpon
         IF ( tmask_atl(jo) == 1 .AND. xolatt(jo) > 40.0_rl ) wa2o(:,jo) = wa2o(:,jo) * 0.0
      END DO
   END IF
   !!
   !!
   !! Verif nombre de voisins
   !!
   IF ( jma2or /= jma2o ) THEN 
      WRITE (nout, *) 'Erreur nombre de voisins dans run.def : '
      WRITE (nout, *) ' jma2o calcule / lu : ', jma2o, jma2or
      !STOP
   ENDIF
   !!
!-$$   !! Ecriture des poids
!-$$   !!
!-$$   WRITE (unit = c_r, fmt = '(1i1)' ) rk_out
!-$$   !
!-$$   IF ( l_wei_i4) THEN 
!-$$      WRITE (unit = c_i, fmt = '(1i1)' ) i_4
!-$$      cfname4 = TRIM(mo_name) // ".wa2o.runoff.i" // TRIM(c_i) // ".r" // TRIM(c_r) // TRIM(c_suffix)
!-$$      OPEN (unit = nwei4a2o, file = TRIM(cfname4), form = 'unformatted', status = 'replace',&
!-$$         & action = 'write')
!-$$      WRITE (nout, *) 'Poids i_4 a -> o: ', TRIM(cfname4)
!-$$   END IF
!-$$   !
!-$$   IF (l_wei_i8) THEN 
!-$$      WRITE (unit = c_i, fmt = '(1i1)' ) i_8
!-$$      cfname8 = TRIM(mo_name) // ".wa2o.runoff.i" // TRIM(c_i) // ".r" // TRIM(c_r) // TRIM(c_suffix)
!-$$      OPEN (unit = nwei8a2o, file = TRIM(cfname8), form = 'unformatted', status = 'replace',&
!-$$         & action = 'write')
!-$$      WRITE (nout, *) 'Poids i_8  a -> o : ', TRIM(cfname8)
!-$$   END IF
!-$$   !
!-$$   cldiag_a2o = TRIM(a2o_name) // '.runcoa.diag' 
!-$$   clw_a2o    = TRIM(mo_name)  // '.wa2o.runcoa'
!-$$   clw_a2o_mct= TRIM(mo_name)  // '.wa2o_mct.runcoa'
!-$$   !
!-$$   CALL wri_weights_a2o (cldiag_a2o, clw_a2o, clw_a2o_mct, "4", l_fulldiag, lo_src_grid_frac=.FALSE., lo_dst_grid_frac=.FALSE., &
!-$$      & co_omsk=TRIM(cotes_omsk), co_amsk=TRIM(cotes_amsk) )         
!-$$   !

  
   !!
   !! Ecriture des poids
   !!
   !! Ouverture des fichiers poids
   !!
   WRITE (unit = c_r, fmt = '(1i1)' ) rk_out
   !
   IF (l_wei_i4) THEN
      WRITE (unit = c_i, fmt = '(1i1)' ) i_4
      cfname4 = TRIM(mo_name) // ".wa2o.rivflu"  // TRIM(c_suffix) // ".i" // TRIM(c_i) // ".r" // TRIM(c_r)
      OPEN (unit = nwei4a2o, file = TRIM(cfname4), form = 'unformatted', status = 'replace',&
         & action = 'write')
      WRITE (nout, *) 'Poids i4 a -> o: ', TRIM(cfname4)
   END IF
   !
   IF (l_wei_i4) THEN 
      WRITE (unit = c_i, fmt = '(1i1)' ) i_8
      cfname8 = TRIM (mo_name) // ".wa2o.rivflu" // TRIM(c_suffix) // ".i" // TRIM(c_i) // ".r" // TRIM(c_r)
      OPEN (unit = nwei8a2o, file = TRIM(cfname8), form = 'unformatted', status = 'replace',&
         & action = 'write')
      WRITE (nout, *) 'Poids i8  a -> o : ', TRIM(cfname8)
   END IF

   !
   cldiag_a2o  = TRIM (a2o_name) // '.rivflu.diag' 
   clw_a2o     = TRIM (mo_name)  // '.wa2o.rivflu'
   clw_a2o_mct = "rmp_"//TRIM(camod_t)//"_to_"//TRIM(comod_t)//"_MOSAIC_rivflu"
   !
   CALL wri_weights_a2o (cldiag_a2o, clw_a2o, clw_a2o_mct, "3", l_fulldiag, lo_src_grid_frac=.FALSE., lo_dst_grid_frac=.FALSE., &
      &  co_omsk='noperio', co_amsk='full' )

   !!
   IF (l_wei_i4) THEN
      WRITE (nout,*) 'Fermeture poids i4'
      CLOSE (unit = nwei8a2o)
   END IF
   IF (l_wei_i8) THEN
      WRITE (nout,*) 'Fermeture poids i8 '
      CLOSE (unit = nwei4a2o)
   END IF
   !!
   WRITE (nout,*) 'Appel flioclo'
   CALL flioclo
   !!
   STOP
   !!
CONTAINS
   !!
   SUBROUTINE diag_itarget (clmess, lwrite)
      CHARACTER (len=*), INTENT (in) :: clmess
      LOGICAL, INTENT (in) :: lwrite
      INTEGER, SAVE :: nappel = 0
      CHARACTER (len=2) :: cc
      !!
      nappel = nappel + 1
      !! 
      itarget = 0_il ; wtarget = 0.0_rl
      DO jo = 1, jpon
         DO jn = 1, jpa2o
            ja = ka2o (jn, jo) 
            IF (ja /= 0 ) THEN
               itarget (ja) = itarget (ja) + 1_il
               wtarget (ja) = wtarget (ja) + wa2o (jn, jo)
            ENDIF
         END DO
      END DO
      !!
      !CALL lbc (itarget, naperio, 'T', jpai, jpaj)
      !CALL lbc (wtarget, naperio, 'T', jpai, jpaj)
      !!
      IF (lwrite) THEN 
         !$$$      WRITE(nout,*) 'itarget, etape '// clmess
         !$$$      CALL prihin (RESHAPE(itarget,(/jpai,jpaj/)),1_il,nout)
         WRITE (unit = cc, fmt = '(1I2.2)' ) nappel
         CALL fliodefv (nid_it, 'itarget'    // cc, (/1, 2/), v_t=flio_i4)
         CALL fliodefv (nid_it, 'ntarget'    // cc, (/1, 2/), v_t=flio_i4)
         CALL fliodefv (nid_it, 'wtarget'    // cc, (/1, 2/), v_t=flio_r4)
         CALL fliodefv (nid_it, 'non_target' // cc, (/1, 2/), v_t=flio_i4)


         CALL flioputa (nid_it, 'itarget' // cc, 'long_name ', clmess // ' itarget' // cc)
         CALL flioputv (nid_it, 'itarget' // cc, MIN (1, RESHAPE (itarget, (/jpai, jpaj/))) )

         CALL flioputa (nid_it, 'ntarget' // cc, 'long_name ', clmess // ' ntarget' // cc)
         CALL flioputv (nid_it, 'ntarget' // cc, RESHAPE (itarget, (/jpai, jpaj/)) )

         CALL flioputa (nid_it, 'wtarget' // cc, 'long_name ', clmess // ' wtarget' // cc)
         CALL flioputv (nid_it, 'wtarget' // cc, RESHAPE (wtarget, (/jpai, jpaj/)) )

         wtarget = 0
         WHERE (itarget .EQ. 0 ) wtarget = 1.0_rl
         CALL flioputa (nid_it, 'non_target' // cc, 'long_name ', clmess // ' non_target' // cc)
         CALL flioputv (nid_it, 'non_target' //cc, RESHAPE (NINT (wtarget), (/jpai, jpaj/)) )
      END IF
      !!
   END SUBROUTINE diag_itarget
   !!
   SUBROUTINE diag_idest (clmess, lwrite)
      CHARACTER (len=*), INTENT (in) :: clmess
      LOGICAL, INTENT (in) :: lwrite
      INTEGER, SAVE :: nappel = 0
      CHARACTER (len=2) :: cc
      !!
      nappel = nappel + 1
      !! 
      idest = 0_il ; wdest = 0.0_rl
      DO jo = 1, jpon
         DO jn = 1, jpa2o
            ja = ka2o (jn, jo) 
            IF (ja /= 0 ) THEN
               idest (jo) = idest  (jo) + 1_il
               wdest (jo) = wdest  (jo) + wa2o (jn, jo)
            ENDIF
         END DO
      END DO
      !!
      !CALL lbc (itarget, naperio, 'T', jpai, jpaj)
      !CALL lbc (wtarget, naperio, 'T', jpai, jpaj)
      !!
      IF (lwrite) THEN 
         !$$$      WRITE(nout,*) 'idest, etape '// clmess
         !$$$      CALL prihin (RESHAPE(idest,(/jpoi,jpoj/)),1_il,nout)
         WRITE (unit = cc, fmt = '(1I2.2)' ) nappel
         CALL fliodefv (nid_id, 'idest'    // cc, (/1, 2/), v_t=flio_i4)
         CALL fliodefv (nid_id, 'ndest'    // cc, (/1, 2/), v_t=flio_i4)
         CALL fliodefv (nid_id, 'wdest'    // cc, (/1, 2/), v_t=flio_r4)
         CALL fliodefv (nid_id, 'non_dest' // cc, (/1, 2/), v_t=flio_i4)


         CALL flioputa (nid_id, 'idest' // cc, 'long_name ', clmess // ' idest' // cc)
         CALL flioputv (nid_id, 'idest' // cc, MIN (1, RESHAPE (idest, (/jpoi, jpoj/))) )

         CALL flioputa (nid_id, 'ndest' // cc, 'long_name ', clmess // ' ndest' // cc)
         CALL flioputv (nid_id, 'ndest' // cc, RESHAPE (idest, (/jpoi, jpoj/)) )

         CALL flioputa (nid_id, 'wdest' // cc, 'long_name ', clmess // ' wdest' // cc)
         CALL flioputv (nid_id, 'wdest' // cc, RESHAPE (wdest, (/jpoi, jpoj/)) )

         wdest = 0
         WHERE (idest .EQ. 0 ) wdest = 1.0_rl
         CALL flioputa (nid_id, 'non_dest' // cc, 'long_name ', clmess // ' non_dest' // cc)
         CALL flioputv (nid_id, 'non_dest' //cc, RESHAPE (NINT (wdest), (/jpoi, jpoj/)) )
      END IF
      !!
   END SUBROUTINE diag_idest
   !!
   !!
   SUBROUTINE int_wei
      !!
      IMPLICIT NONE
      WRITE(nout,*) 'Debut normalisation'
      !!
      IF (.NOT. lint_atm) THEN
         WRITE(nout,*) 'Multiplication par les surfaces atm'
         DO jo = 1, jpon
            DO jn = 1, jma2o
               ja = ka2o (jn, jo)
               IF (ja > 0 ) wa2o (jn,jo) = wa2o (jn,jo) * xasrft (ja)
            END DO
         ENDDO
      ENDIF
      !!
      IF (.NOT. lint_oce) THEN
         WRITE (nout,*) 'Division par les surfaces oce'
         DO jo = 1, jpon
            DO jn = 1, jma2o
               wa2o (jn,jo) = wa2o (jn,jo) / xosrft (jo)
            END DO
         ENDDO
      ENDIF
   END SUBROUTINE int_wei
   !!
   SUBROUTINE complet_run (ka1, ka2, kn)
      INTEGER (kind=il), INTENT(in) :: ka1, ka2 ! Index of atm boxes
      INTEGER (kind=il), INTENT(in) :: kn ! Number of neighbors
      INTEGER (kind=il) :: jt
      !!
      DO jo = 1, jpon
         IF (iomskt(jo) == 1 ) CYCLE
         IF (iomskp(jo) .EQ. 1_il ) CYCLE
         DO jn = 1, jpa2o
            IF (ka2o(jn,jo) == ka1 ) THEN
               nvo(jo) = nvo(jo)+1
               IF (nvo(jo) > jpa2o ) THEN
                  WRITE(nout,*) 'Pas assez de voisins pour la completion '
                  WRITE(nout,fmt='(1I7,2I4,2F10.1)' ) ka1, m2ai(ka1), m2aj(ka1), &
                     &   xalont(ka1), xalatt(ka1)
                  WRITE(nout,fmt='(1I7,2I4,2F10.1)' ) ka2, m2ai(ka2), m2aj(ka2), &
                     &   xalont(ka2), xalatt(ka2)
                  WRITE(nout,fmt='(1I7,2I4,2F10.1,2I8)') jo, m2oi(jo), m2oj(jo), &
                     &   xolont(jo), xolatt(jo), jn, nvo(jo)
                  DO jt = 1, jpa2o
                     WRITE(nout,fmt=*) jt, ka2o(jt,jo), xalont(ka2o(jt,jo)), xalatt(ka2o(jt,jo))
                  ENDDO
               END IF
               ka2o (nvo (jo), jo) = ka2
               wa2o (nvo (jo), jo) = wa2o(jn,jo) * xasrft(ka2) / xasrft(ka1) / REAL(kn,KIND=rl)
            END IF
         END DO
      ENDDO
   END SUBROUTINE complet_run
   !!
   SUBROUTINE gather_wei (clmess)
      CHARACTER (len=*), INTENT (in) :: clmess
      INTEGER (kind=il) :: jn1, jn2, jo2
      !! Eliminate redundancy
      DO jo = 1, jpon
         DO jn1 = 1, jpa2o-1
            IF (ka2o (jn1,jo) == 0 ) CYCLE
            DO jn2 = jn1+1, jpa2o
               IF (ka2o (jn1, jo) == ka2o (jn2, jo) ) THEN 
                  WRITE(nout,*) 'Redondance ', jo, jn1, jn2, ka2o(jn1,jo), ka2o (jn2,jo), wa2o(jn1,jo), wa2o(jn2,jo)
                  wa2o (jn1, jo) = wa2o (jn1, jo) + wa2o (jn2, jo)
                  ka2o (jn2, jo) = 0
               END IF
            END DO
         END DO
      END DO
      !!
      !! Seek for strangeness
      DO jo = 1, jpon
         DO jn = 1, jpa2o
            ja = ka2o (jn, jo)
            IF (ja == 0) CYCLE
            IF (wa2o (jn, jo) == 0.0E0 ) THEN 
               WRITE (nout, *) 'Null weight : ', jo, jn, ja, locot (jo)
            END IF
         END DO
      END DO
      !!
      !! Periodicity
      !DO jn = 1, jpa2o
      !   CALL lbc (wa2o (jn,:), noperio, 'T', jpoi, jpoj)
      !   CALL lbc (ka2o (jn,:), noperio, 'T', jpoi, jpoj)
      !END DO
      CALL diag_itarget (' gather/perio - ' // clmess, lwrite=.TRUE.)
      CALL diag_idest   (' gather/perio - ' // clmess, lwrite=.TRUE.)
      !!
      !! Gather weights
      DO jo = 1, jpon
         ktemp = ka2o (:,jo) ; wtemp = wa2o (:,jo)
         ka2o (:,jo) = 0_il  ; wa2o (:,jo) = 0.0_rl
         kn = 1_il
         DO jo2 = 1, jpa2o
            IF (ktemp (jo2) /= 0_il ) THEN
               ka2o (kn, jo) =  ktemp (jo2)
               wa2o (kn, jo) =  wtemp (jo2)
               kn = kn + 1_il
            END IF
         END DO
      END DO
      nvo = COUNT (ka2o /= 0_il, DIM = 1)
      jma2o = MAXVAL (nvo)
      !
      !!
      !! Periodicity
      !DO jn = 1, jpa2o
      !   CALL lbc (wa2o(jn,:), noperio, 'T', jpoi, jpoj)
      !   CALL lbc (ka2o(jn,:), noperio, 'T', jpoi, jpoj)
      !END DO
      !!
      nvo = COUNT (ka2o /= 0_il, DIM = 1)
      jma2o = MAXVAL (nvo)
      !!
   END SUBROUTINE gather_wei
   !!
   SUBROUTINE verif (clmess, l_non_a)
      !!
      CHARACTER (len=*), INTENT (in) :: clmess
      INTEGER :: ja
      LOGICAL, INTENT (in), OPTIONAL :: l_non_a
      !!
      nvo = COUNT (ka2o /= 0_il, DIM = 1)
      jma2o = MAXVAL (nvo)
      CALL diag_itarget (clmess, lwrite=.TRUE.)
      CALL diag_idest   (clmess, lwrite=.TRUE.)
      !!
      WRITE (nout, *) ' --- Verifs -- : ', TRIM (clmess)
      WRITE (nout, *) 'wa2o    ', MINVAL (wa2o), MAXVAL (wa2o), COUNT (wa2o > 0.0_rl)
      WRITE (nout, *) 'ka2o    ', MINVAL (ka2o), MAXVAL (ka2o), COUNT (ka2o > 0 )
      WRITE (nout, *) 'xasrft  ', MINVAL (xasrft), MAXVAL (xasrft)
      WRITE (nout, *) 'o2amask ', MINVAL (o2amask), MAXVAL (o2amask), SUM (o2amask)
      WRITE (nout, *) 'xosrft  ', MINVAL (xosrft), MAXVAL (xosrft)
      WRITE (nout, *) 'iomskt  ', MINVAL (iomskt), MAXVAL (iomskt), COUNT (iomskt == 0)
      WRITE (nout, *) 'iomskp  ', MINVAL (iomskp), MAXVAL (iomskp), COUNT (iomskp == 0)
      WRITE (nout, *) 'iamskt  ', MINVAL (iamskt), MAXVAL (iamskt), COUNT (iamskt == 0)
      WRITE (nout, *) 'locot   ', COUNT (locot)
      WRITE (nout, *) 'Points non attribues : ', COUNT (itarget .EQ. 0 )

      IF (PRESENT (l_non_a)) THEN 
         DO ja = 1, jpan
            IF (itarget (ja) == 0 .AND. iamskp(ja) == 0 .AND. (laland (ja) .OR. lacot(ja) )) THEN
!-$$               WRITE (UNIT=nout,FMT='("Point atm non attribues : ", 3I7, 2F7.1, 1I4)' ) ja, m2ai(ja), m2aj (ja), xalont(ja), xalatt(ja), itarget(ja)
            WRITE (nout,*) ja, m2ai(ja), m2aj (ja), xalont(ja), xalatt(ja), itarget(ja), laland(ja), lacot(ja), laoce(ja)
         ENDIF
      END DO
   END IF
END SUBROUTINE verif
!!
!! 
SUBROUTINE noroute
   !! Determine les points atmospheres non routes
   lanoroute = .TRUE.

   DO jn = 1, jpa2o
      DO jo = 1, jpon
         ja = ka2o ( jo, jn)
         IF ( ja /= 0 .AND. wa2o (jo,jn) > 0.0_rl ) THEN
            lanoroute = .FALSE.
         END IF
      END DO
   END DO

END SUBROUTINE noroute
!!
SUBROUTINE bilan (clmess, c_case, c_int_atm, c_int_oce)
   !!
   CHARACTER (len=*), INTENT (in) :: clmess
   CHARACTER (len=*), INTENT (in) :: c_case ! Type de champ d'entree
   CHARACTER (len=*), INTENT (in) :: c_int_atm ! Type d'integrale sur l'atm
   CHARACTER (len=*), INTENT (in) :: c_int_oce ! Type d'integrale sur l'ocean
   !!
   WRITE (nout,*) "Bilan :" // TRIM (clmess) // ", cas :", TRIM (c_case), ", c_int_atm :", TRIM (c_int_atm),&
      &   ", c_int_oce :", TRIM(c_int_oce), "."
   !!
   za = 0.0_rl
   !!
   SELECT CASE (TRIM (c_case))
   CASE ('complet')
      za = 1.0_rl * REAL (1-iamskp, KIND=rl)
      SELECT CASE (TRIM (c_int_atm))
      CASE ('Integral')
         za = za * xasrft
         zsuma = SUM (za)
      CASE ('Local')
         zsuma = DOT_PRODUCT (za, xasrft)
      CASE default
         WRITE (nout,*) 'Erreur type de bilan atm' ; STOP
      END SELECT
      !!
   CASE ('terre')
      WHERE (laland .OR. lacot)
         za = 1.0_rl * REAL (1-iamskp, KIND=rl)
      END WHERE
      SELECT CASE (TRIM (c_int_atm))
      CASE ('Integral')
         za = za * xasrft 
         zsuma = SUM (za)
      CASE ('Local')
         zsuma = DOT_PRODUCT (za, xasrft*(1.0-o2amask))
      CASE default
         WRITE (nout,*) 'Erreur type de bilan atm' ; STOP
      END SELECT
      !!
   CASE ('terre100')
      WHERE (laland)
         za = 1.0_rl * REAL (1-iamskp, KIND=rl)
      END WHERE
      SELECT CASE (TRIM (c_int_atm))
      CASE ('Integral')
         za = za * xasrft 
         zsuma = SUM (za)
      CASE ('Local')
         zsuma = DOT_PRODUCT (za, xasrft)
      CASE default
         WRITE (nout,*) 'Erreur type de bilan atm' ; STOP
      END SELECT
      !!
   CASE ('ocean')
      WHERE (lacot)
         za = 1.0_rl * REAL (1-iamskp, KIND=rl)
      END WHERE
      SELECT CASE (TRIM (c_int_atm))
      CASE ('Integral')
         za = za * xasrft
         zsuma = SUM (za)
      CASE ('Local')
         zsuma = DOT_PRODUCT (za, xasrft*o2amask)
      CASE default
         WRITE (nout,*) TRIM(clmess), ' : Erreur type de bilan atm'  ; STOP
      END SELECT
      !!
   CASE ('cote')
      WHERE (lacot)
         za = 1.0_rl * REAL (1-iamskp, KIND=rl)
      END WHERE
      SELECT CASE (TRIM (c_int_atm))
      CASE ('Integral')
         za = za * xasrft
         zsuma = SUM (za)
      CASE ('Local')
         zsuma = DOT_PRODUCT (za, xasrft*o2amask)
      CASE default
         WRITE (nout,*) 'Erreur type de bilan atm' ; STOP
      END SELECT
      !!
   CASE default
      WRITE (nout,*)'Erreur choix de cas' ; STOP
      STOP
   END SELECT
   !!
   CALL inter_a2o (za, zo)
   !!
   SELECT CASE (TRIM (c_int_oce))
   CASE ('Integral')
      zsumo = DOT_PRODUCT (zo, REAL(1-iomskp, KIND=rl))
   CASE ('Local')
      zsumo = DOT_PRODUCT (zo*xosrft,REAL(1-iomskp, KIND=rl))
   CASE default
      WRITE (nout,*) TRIM (clmess), ' : Erreur type de bilan ' ; STOP
   END SELECT
   !!
   WRITE (nout, fmt='("  bilan atm: ", 1E15.6, ", bilan oce: ", 1E15.6)' ) zsuma, zsumo
   !!
   RETURN
   !!
END SUBROUTINE bilan
!!
END PROGRAM cotes_etal

