! -*- Mode: f90 -*-
MODULE mod_inter
   USE modeles
   USE mod_lbc
CONTAINS
   SUBROUTINE inter_o2a (pin, pout)
      !> Interpolation ocean -> atmosphere
      IMPLICIT NONE
      !!
      REAL (kind = rl), DIMENSION (jpon), INTENT ( in) :: pin
      REAL (kind = rl), DIMENSION (jpan), INTENT (out) :: pout
      INTEGER (kind = il) :: ja, jn, kn
      !!
      pout = 0.0_rl
      DO ja = 1, jpan
         DO jn = 1, jmo2a
            kn = ko2a (jn, ja)
            IF (kn > 0) pout (ja) = pout (ja) + wo2a (jn, ja) * pin (kn)
         END DO
      END DO
      !!
      CALL lbc (pout, naperio, 'T', jpai, jpaj)
      !!
      RETURN
      !!
   END SUBROUTINE inter_o2a
   !!
   SUBROUTINE inter_a2o (pin, pout)
      !> Interpolation ocean -> atmosphere
      IMPLICIT NONE
      !!
      REAL (kind = rl), DIMENSION (jpan), INTENT ( in) :: pin
      REAL (kind = rl), DIMENSION (jpon), INTENT (out) :: pout
      INTEGER (kind = il) :: jo, jn, kn
      !!
      pout = 0.0_rl
      DO jo = 1, jpon
         DO jn = 1, jma2o
            kn = ka2o (jn, jo)
            IF (kn > 0) pout (jo) = pout (jo) + wa2o (jn, jo) * pin (kn)
         END DO
      END DO
      !!
      CALL lbc (pout, noperio, 'T', jpoi, jpoj)
      !!
      RETURN
      !!
   END SUBROUTINE inter_a2o
   !!
END MODULE mod_inter
