! -*- Mode: f90 -*-
PROGRAM inv_wei
   !
   USE defprec
   USE data_types
   USE fliocom
   USE errioipsl
   IMPLICIT NONE
   !! Useful variables for initialisation
   INTEGER (kind=il) :: nout=6 ! File number for messages
   !!
   !! Lit un fichier de poids IEEE, ecris les diags
   !!
   !! Partie  adapter  la rsolution
!-$$   CHARACTER (LEN=*), PARAMETER :: clname = '/home/data01/marti/CPL/FILES/ORCA2lgmxLMD9671/mozaic.wa2o.calvin.i4.r8'

!-$$   CHARACTER (LEN=*), PARAMETER :: clname = 'mozaic.wa2o.i4.r8'
!-$$   CHARACTER (LEN=8), PARAMETER :: clweight =  "WEIGHTS2", cladress = "ADRESSE2"
!-$$   INTEGER (kind=il), PARAMETER :: jpi1=96 , jpj1=72 ! Dimensions modele 1
!-$$   INTEGER (kind=il), PARAMETER :: jpi2=182, jpj2=149 ! Dimensions modele 2
!-$$   INTEGER (kind=il), PARAMETER :: jp1to2 = 109, jp2to1 = 100 ! Nombre de voisins

!-$$   CHARACTER (LEN=*), PARAMETER :: clname = 'mozaic.wa2o.runoff.i4.r8'
!-$$   CHARACTER (LEN=8), PARAMETER :: clweight =  "WEIGHTS3", cladress = "ADRESSE3"
!-$$   INTEGER (kind=il), PARAMETER :: jpi1=72 , jpj1=46 ! Dimensions modele 1
!-$$   INTEGER (kind=il), PARAMETER :: jpi2=92, jpj2=76 ! Dimensions modele 2
!-$$   INTEGER (kind=il), PARAMETER :: jp1to2 = 6, jp2to1 = 100 ! Nombre de voisins

!-$$   CHARACTER (LEN=8), PARAMETER :: clweight =  "WEIGHTS5", cladress = "ADRESSE5"
!-$$   INTEGER (kind=il), PARAMETER :: jpi1=96 , jpj1=72 ! Dimensions modele 1
!-$$   INTEGER (kind=il), PARAMETER :: jpi2=182, jpj2=149 ! Dimensions modele 2
!-$$   INTEGER (kind=il), PARAMETER :: jp1to2 = 36, jp2to1 = 10000 ! Nombre de voisins

   CHARACTER (LEN=*), PARAMETER :: clname = 'mozaic.wa2o.runoff.i4.r8'
   CHARACTER (LEN=8), PARAMETER :: clweight =  "WEIGHTS4", cladress = "ADRESSE4"
   INTEGER (kind=il), PARAMETER :: jpi1=96 , jpj1=72   ! Dimensions modele 1
   INTEGER (kind=il), PARAMETER :: jpi2=182, jpj2=149  ! Dimensions modele 2
   INTEGER (kind=il), PARAMETER :: jp1to2 = 163, jp2to1 = 100 ! Nombre de voisins

!-$$   CHARACTER (LEN=*), PARAMETER :: clname = 'mozaic.wa2o.runoff.i4.r8'
!-$$   CHARACTER (LEN=8), PARAMETER :: clweight =  "WEIGHTS4", cladress = "ADRESSE4"
!-$$   INTEGER (kind=il), PARAMETER :: jpi1=144, jpj1=144  ! Dimensions modele 1
!-$$   INTEGER (kind=il), PARAMETER :: jpi2=182, jpj2=149  ! Dimensions modele 2
!-$$   INTEGER (kind=il), PARAMETER :: jp1to2 = 7, jp2to1 = 100 ! Nombre de voisins

   !!
   INTEGER (kind=il), PARAMETER :: jp1 = jpi1 * jpj1, jp2 = jpi2 * jpj2  ! Dimensions
   !!
   REAL    (kind=rl), DIMENSION (jp1to2, jp2) :: w1to2
   INTEGER (kind=il), DIMENSION (jp1to2, jp2) :: k1to2
   INTEGER (kind=il), DIMENSION (jp2) :: nv1to2

   REAL    (kind=rl), DIMENSION (jp2to1, jp1) :: w2to1
   INTEGER (kind=il), DIMENSION (jp2to1, jp1) :: k2to1
   INTEGER (kind=il), DIMENSION (jp1) :: nv2to1 

   REAL    (kind=rl), DIMENSION (:), ALLOCATABLE :: w_t
   INTEGER (kind=il), DIMENSION (:), ALLOCATABLE :: k_t
   REAL    (kind=rl), DIMENSION (:,:,:), ALLOCATABLE :: w_3d
   INTEGER (kind=il), DIMENSION (:,:,:), ALLOCATABLE :: k_3d

   INTEGER :: nwei8 = 23,  nc1, nc2

   INTEGER (kind=il) :: ji1, jj1, ji2, jj2, j1, j2, jn1, jn2, ierr=0, jm1to2, jm2to1

   ! Lecture des poids
   OPEN (unit = nwei8, file = TRIM(clname), form = 'unformatted', status = 'old', action = 'read')
   WRITE (nout, *) 'Fichier poids : ', TRIM (clname)

   !!
   WRITE (nout,*) 'Grille origine : ', jpi1, jpj1, jp1
   WRITE (nout,*) 'Grille arrive  : ', jpi2, jpj2, jp2
   WRITE (nout,*) 'Voisins 1 -> 2 : ', jp1to2
   WRITE (nout,*) 'Voisins 2 -> 1 : ', jp2to1

   ALLOCATE (k_t (jp1to2*jp2), STAT=ierr) ; CALL chka ("allocate k_t (jp1to2*jp2)", ierr)
   WRITE (unit = nout, fmt = *) 'Will try to read : ', cladress
   CALL locrint (cladress, k_t(1:jp1to2*jp2), jp1to2*jp2, nwei8, ierr, nout) ;  IF (ierr /= 0) STOP 201
   k1to2 (1:jp1to2, 1:jp2) = RESHAPE (k_t (1:jp1to2 * jp2) , (/ jp1to2, jp2 /))
   DEALLOCATE (k_t, STAT=ierr)  ; CALL chka ("deallocate k_t", ierr)

   ALLOCATE (w_t (jp1to2*jp2), STAT=ierr) ; CALL chka ("allocate w_t (jp1to2*jp2)", ierr)
   WRITE (unit = nout, fmt = *) 'Will try to read : ', clweight
   CALL locread (clweight, w_t(1:jp1to2*jp2), jp1to2*jp2, nwei8, ierr, nout) ;  IF (ierr /= 0) STOP 201
   w1to2 (1:jp1to2, 1:jp2) = RESHAPE (w_t (1:jp1to2 * jp2) , (/ jp1to2, jp2 /))
   DEALLOCATE (w_t, STAT=ierr) ; CALL chka ("deallocate w_t", ierr)

   nv1to2 = COUNT (k1to2 /= 0, DIM=1)
   jm1to2 = MAXVAL (nv1to2)
   WRITE (nout,*) 'nv1to2 : ', jm1to2
   nv2to1 = 0_il
   !!
   ! Inversion
   WRITE (nout,*) 'Start inversion '
   DO j2 = 1, jp2 ! Boucle sur les points cibles
      DO jn2 = 1, jp1to2 ! Boucle sur les voisins
         j1 = k1to2 (jn2,j2) ! j1 : numro du point sur la grille origine
         IF (j1 == 0) CYCLE  ! 0 : pas de point cible
         IF ( j1 > SIZE (nv2to1) ) WRITE (nout,*) 'Error - j1 (#1) ', j1
         nv2to1 (j1) = nv2to1 (j1) + 1 ! On incremente le nombre de points cible trouvs
         jn1 = nv2to1 (j1) 
         IF (jn1 .GT. jp2to1) THEN ! 
            WRITE(nout,*) 'Error - jn1, jp2to1, jn2, j1, j2 : ', jn1, jp2to1, jn2, j1, j2
            STOP
         END IF
         IF ( jn1 > SIZE (k2to1, 1) ) WRITE (nout,*) 'Error - jn1 ', jn1
         IF ( j1  > SIZE (k2to1, 2) ) WRITE (nout,*) 'Error - j1 (#2)', j1
         k2to1 (jn1,j1) = j2
         w2to1 (jn1,j1) = w1to2(jn2,j2)
      END DO
   END DO
   jm2to1 = MAXVAL (nv2to1)
   WRITE (nout, *) 'nv2to1 : ', jm2to1

   ! Ecriture sur grille d'arrivee
   !    CALL ipsldbg (new_status=.TRUE. )
   !
   CALL fliocrfd ('diag1to2.nc', (/'x   ', 'y   ', 'n   ' /), (/jpi2, jpj2, jm1to2/), nc2, mode='REPLACE')

   CALL fliodefv (nc2, 'Weights_Max', (/1_il,2_il/), v_t=flio_r4, standard_name='Max weights')
   CALL fliodefv (nc2, 'Neighbors'  , (/1_il,2_il/), v_t=flio_i4, standard_name='Neighbors')
   CALL fliodefv (nc2, 'Weights_Sum', (/1_il,2_il/), v_t=flio_r4, standard_name='Sum weights')
   CALL fliodefv (nc2, 'Weights', (/1_il,2_il,3_il/), v_t=flio_r4, standard_name='Weights')
   CALL fliodefv (nc2, 'Adresses',(/1_il,2_il,3_il/), v_t=flio_i4, standard_name='Adresses')
   CALL fliodefv (nc2, 'Index_I', (/1_il,2_il,3_il/), v_t=flio_i4 )
   CALL fliodefv (nc2, 'Index_J', (/1_il,2_il,3_il/), v_t=flio_i4 )

   CALL flioputv (nc2, 'Weights_Max', RESHAPE (MAXVAL(w1to2,DIM=1), (/jpi2, jpj2/)) )
   CALL flioputv (nc2, 'Neighbors',   RESHAPE (MAX(0_il, nv1to2) , (/jpi2, jpj2/)) )
   CALL flioputv (nc2, 'Weights_Sum', RESHAPE (SUM   (w1to2,DIM=1), (/jpi2, jpj2/)) )

   ALLOCATE (w_3d(jpi2, jpj2, jm1to2))
   ALLOCATE (k_3d(jpi2, jpj2, jm1to2))

   DO jn2 = 1_il, jm1to2
      DO jj2 = 1_il, jpj2
         DO ji2 = 1_il, jpi2
            w_3d (ji2, jj2, jn2) = REAL (w1to2 (jn2, m1_2(ji2, jj2)), KIND=rl)
            k_3d (ji2, jj2, jn2) = INT  (k1to2 (jn2, m1_2(ji2, jj2)), KIND=il)
         END DO
      END DO
   END DO
   !
   CALL flioputv (nc2, 'Weights' , w_3d(:,:,:) )
   CALL flioputv (nc2, 'Adresses', k_3d(:,:,:) )
   !
   DEALLOCATE (w_3d) ; DEALLOCATE (k_3d)
   CALL flioclo (nc2)

   ! Ecriture sur grille de depart
   ! CALL ipsldbg (new_status=.TRUE. )
   !
   CALL fliocrfd ('diag2to1.nc', (/'x   ', 'y   ', 'n   ' /), (/jpi1, jpj1, jm2to1 /), nc1, mode='REPLACE')

   CALL fliodefv (nc1, 'Weights_Max', (/1_il,2_il/), v_t=flio_r4, standard_name='Max weights')
   CALL fliodefv (nc1, 'Neighbors'  , (/1_il,2_il/) , v_t=flio_i4, standard_name='Neighbors')
   CALL fliodefv (nc1, 'Weights_Sum', (/1_il,2_il/) , v_t=flio_r4, standard_name='Sum weights')
   CALL fliodefv (nc1, 'Weights', (/1_il,2_il,3_il/), v_t=flio_r4, standard_name='Weights')
   CALL fliodefv (nc1, 'Adresses',(/1_il,2_il,3_il/), v_t=flio_i4, standard_name='Adresses')
   CALL fliodefv (nc1, 'Index_I', (/1_il,2_il,3_il/), v_t=flio_i4 )
   CALL fliodefv (nc1, 'Index_J', (/1_il,2_il,3_il/), v_t=flio_i4 )

   CALL flioputv (nc1, 'Weights_Max', RESHAPE (MAXVAL(w2to1,DIM=1), (/jpi1, jpj1/)) )
   CALL flioputv (nc1, 'Neighbors',   RESHAPE (MAX   (0_il, nv2to1), (/jpi1, jpj1/)) )
   CALL flioputv (nc1, 'Weights_Sum', RESHAPE (SUM   (w2to1,DIM=1), (/jpi1, jpj1/)) )

   ALLOCATE (w_3d(jpi1, jpj1, jm2to1))
   ALLOCATE (k_3d(jpi1, jpj1, jm2to1))

   DO jn1 = 1_il, jm2to1
      DO jj1 = 1_il, jpj1
         DO ji1 = 1_il, jpi1
            w_3d (ji1, jj1, jn1) = REAL (w2to1 (jn1, m1_1(ji1, jj1)), KIND=rl)
            k_3d (ji1, jj1, jn1) = INT  (k2to1 (jn1, m1_1(ji1, jj1)), KIND=il)
         END DO
      END DO
   END DO
   !
   CALL flioputv (nc1, 'Weights' , w_3d(:,:,:))
   CALL flioputv (nc1, 'Adresses', k_3d(:,:,:))
   !
   DEALLOCATE (w_3d) ; DEALLOCATE (k_3d)
   CALL flioclo (nc1)
   !
CONTAINS
   !!
   SUBROUTINE chka (clmess, kerr)
      IMPLICIT NONE
      CHARACTER (len=*), INTENT (in) :: clmess
      INTEGER (kind=il), INTENT (in) :: kerr
      LOGICAL :: l_deb = .TRUE.
      !!
      IF (kerr == 0) THEN 
         IF (l_deb) THEN
            WRITE (nout,*) "OK : ", TRIM (clmess)
         END IF
      ELSE
         WRITE (nout,*) "ERROR # ", kerr, " : ", TRIM (clmess)
      END IF
   END SUBROUTINE chka
   !!
   ELEMENTAL FUNCTION m2i1 (k1) ! 2D indexes from 1D, grille 1
      IMPLICIT NONE
      INTEGER (kind=il) :: m2i1
      INTEGER (kind=il), INTENT (in) :: k1
      IF (k1 == 0_il ) THEN 
         m2i1 = 0_il
      ELSE
         m2i1 = MOD (k1 - 1_il, jpi1) + 1_il
      END IF
      RETURN
   END FUNCTION m2i1
   ELEMENTAL FUNCTION m2j1 (k1)
      IMPLICIT NONE
      INTEGER (kind=il) :: m2j1
      INTEGER (kind=il), INTENT (in) :: k1
      IF (k1 == 0_il ) THEN 
         m2j1 = 0_il
      ELSE
         m2j1 = (k1 - 1_il) / jpi1 + 1_il
      END IF
      RETURN
   END FUNCTION m2j1
   ELEMENTAL FUNCTION m2i2 (k2) ! 2D indexes from 1D, grille 2
      IMPLICIT NONE
      INTEGER (kind=il) :: m2i2
      INTEGER (kind=il), INTENT (in) :: k2
      IF (k2 == 0_il ) THEN 
         m2i2 = 0_il
      ELSE 
         m2i2 = MOD (k2 - 1_il, jpi2) + 1_il
      END IF
      RETURN
   END FUNCTION m2i2
   ELEMENTAL FUNCTION m2j2 (k2)
      IMPLICIT NONE
      INTEGER (kind=il) :: m2j2
      INTEGER (kind=il), INTENT (in) :: k2
      IF (k2 == 0_il ) THEN 
         m2j2 = 0_il
      ELSE 
         m2j2 = (k2 - 1_il) / jpi2 + 1_il
      END IF
      RETURN
   END FUNCTION m2j2
   ELEMENTAL FUNCTION m1_2 (ki2, kj2)  ! 1D indexes from 2D, grille 2
      IMPLICIT NONE
      INTEGER (kind=il) :: m1_2
      INTEGER (kind=il), INTENT (in) :: ki2, kj2
      m1_2 = ki2 + (kj2 - 1_il) * jpi2
      RETURN
   END FUNCTION m1_2
   ELEMENTAL FUNCTION m1_1 (ki1, kj1)  ! 1D indexes from 2D, grille 1
      IMPLICIT NONE
      INTEGER (kind=il) :: m1_1
      INTEGER (kind=il), INTENT (in) :: ki1, kj1
      m1_1 = ki1 + (kj1 - 1_il) * jpi1
      RETURN
   END FUNCTION m1_1
   !
   SUBROUTINE locread (cdfldn, pfield, kdimax, knulre, kflgre, kout)
      !
      !     Purpose:
      !     -------
      !     Find string cdfldn on unit knulre and read array pfield
      !
      !     Reference:
      !     ---------
      !     See OASIS manual (1995) 
      !
      !     History:
      !     -------
      !       Version   Programmer     Date      Description
      !       -------   ----------     ----      -----------  
      !       2.0       L. Terray      95/09/01  created
      !
      ! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      !
      IMPLICIT NONE
      !
      CHARACTER (len = 8), INTENT (in) :: cdfldn ! Name of field to search for
      INTEGER (kind=il), INTENT ( in) :: kdimax, knulre    ! Field dimension, unit to read
      INTEGER (kind=il), INTENT ( in) :: kout              ! Standard output
      INTEGER (kind=il), INTENT (out) :: kflgre            ! Error status code
      REAL (kind=rl)  , INTENT (out), DIMENSION (:) :: pfield ! Field
      REAL (kind=rk_in), DIMENSION (:), ALLOCATABLE :: ztemp
      INTEGER (kind=il) :: ki
      !
      CHARACTER (len = 8) clecfl
      INTEGER (kind=il) :: kerr
      !
      !*    1. Initialization
      !        --------------
      !
      WRITE (UNIT = kout, FMT = '("Locread :  Read field ", A8, " in unit = ", 1I3, " Dim : ", 1I8)' ) cdfldn, knulre, kdimax
      kerr = 0 ; ki = -1
      !
      !     2. Find field in file
      !        ------------------
      IF (ALLOCATED (ztemp)) DEALLOCATE (ztemp)
      ALLOCATE (ztemp (1: kdimax), STAT = kerr )
      IF (kerr /= 0 ) THEN 
         WRITE (kout, *) 'Locread - Error allocating ztemp : ', kerr
         kflgre = kerr
         RETURN
      END IF
      !
      REWIND (UNIT = knulre)
200   CONTINUE
      !* Find string
      READ (UNIT = knulre, ERR = 200, END = 210) clecfl
      IF (clecfl /= cdfldn ) GO TO  200
      !* Read associated field
      WRITE (unit = kout, fmt = *) 'Locread - Field found : ', clecfl
      !$$$    READ (UNIT = knulre, IOSTAT = kerr, ERR = 210, END = 210 ) ztemp (1: kdimax)
      !$$$    READ (UNIT = knulre, ERR = 210, END = 210 ) ztemp (1: kdimax)
      ki = -2
      READ (UNIT = knulre, ERR = 210, END = 210 ) (ztemp (ki), ki = 1, kdimax)
      IF (kerr == 0 ) THEN 
         !* Reading done and ok
         pfield (1: kdimax) = REAL (ztemp (1: kdimax), KIND = rl )
         kflgre = 0
      ELSE 
         WRITE (unit = kout, fmt = *) 'Locread - Problem reading field ', cdfldn, kdimax, ki
         kflgre = 1
      END IF
      GO TO 220
      !* Problem in reading
210   kflgre = 1
      WRITE (unit = kout, fmt = *) 'Locread - Problem in reading ', cdfldn, kdimax, ki
220   CONTINUE
      !
      DEALLOCATE (ztemp)
      !
      !*    3. End of routine
      !        --------------
      !
      RETURN
   END SUBROUTINE locread
   !
   SUBROUTINE locrint (cdfldn, kfield, kdimax, knulre, kflgre, kout)
      !
      !     Purpose:
      !     -------
      !     Find string cdfldn on unit knulre and read integer array pfield
      !
      !     Reference:
      !     ---------
      !     See OASIS manual (1995) 
      !
      !     History:
      !     -------
      !       Version   Programmer     Date      Description
      !       -------   ----------     ----      -----------  
      !       2.0       L. Terray      95/09/01  created
      !
      ! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      !
      IMPLICIT none
      !
      CHARACTER (LEN = 8), INTENT (in) :: cdfldn ! Name of field to search for
      INTEGER (kind=il), INTENT (in) :: kdimax, knulre    ! Field dimension, unit to read
      INTEGER (kind=il), INTENT (in) :: kout              ! Standard output
      INTEGER (kind=il), INTENT (out) :: kflgre            ! Error status code
      INTEGER (kind=il), INTENT (inout), DIMENSION (:) :: kfield ! Field
      INTEGER (kind=ik_in), DIMENSION (:), ALLOCATABLE :: itemp
      INTEGER (kind=il) :: ji
      !
      CHARACTER (len = 8) :: clecfl
      INTEGER (kind=il) :: kerr
      !
      !*    1. Initialization
      !        --------------
      !
      WRITE (UNIT = kout, FMT = '("Locrint :  Read field ", A8, " in unit = ", 1I3, " Dim : ", 1I8)' ) cdfldn, knulre, kdimax
      !
      !     2. Find field in file
      !        ------------------
      IF (ALLOCATED (itemp)) DEALLOCATE (itemp)
      ALLOCATE (itemp (1: kdimax), STAT = kerr )
      IF (kerr /= 0 ) THEN 
         WRITE (kout, *) 'Locrint - Error allocating itemp in locrint : ', kerr
         kflgre = kerr
         RETURN
      END IF
      !
      REWIND (UNIT = knulre )
200   CONTINUE
      !
      !* Find string
      READ (UNIT = knulre, ERR = 200, END = 210) clecfl
      IF (clecfl /= cdfldn ) GO TO  200
      !* Read associated field
      WRITE (UNIT = kout, FMT= *) 'Locrint - Field found ', clecfl
      !$$$    READ (UNIT = knulre, END = 210, IOSTAT = kerr) (itemp (ji), ji = 1, kdimax)
      READ (UNIT = knulre, END = 210) (itemp (ji), ji = 1, kdimax)
      IF (kerr == 0 ) THEN 
         !* Reading done and ok
         kfield (1: kdimax) = INT (itemp (1: kdimax), KIND = il)
         kflgre = 0
      ELSE 
         WRITE (unit = kout, fmt = *) 'Locrint - Problem reading field ', cdfldn, kdimax, ji
         kflgre = 1
      END IF
      GO TO 220
      !* Problem in reading
210   kflgre = 1
      WRITE (unit = kout, fmt = *) 'Locrint - Problem in reading ', cdfldn, kdimax, ji
      !
220   CONTINUE
      !
      DEALLOCATE (itemp)
      !
      !*    3. End of routine
      !        --------------
      !
      RETURN
   END SUBROUTINE locrint
   !!
END PROGRAM inv_wei
