! -*- Mode: f90 -*-
!_ ------------------------------------------------------------------
!_ $RCSfile: lbc.f,v $ ($Source: /home/ioipsl/CVSROOT/UTIL/MOZAIC/mozaic/lbc.f,v $ )
!_ $Name:  $   ; $Revision: 1.2 $
!_ $Date: 2002/09/06 14:24:52 $   ; $State: Exp $
!_ $Author: adm $ ; $Locker:  $
!_ ------------------------------------------------------------------
MODULE mod_lbc_2
   USE declare
   IMPLICIT NONE
   !! Periodicite des champs
   INTERFACE lbc
      MODULE PROCEDURE lbc_r, lbc_i, lbc_l
   END INTERFACE
CONTAINS
   !!
   SUBROUTINE lbc_r (ptab, kperio, cd_type, kni, knj) 
      INTEGER (kind=il), INTENT (in) :: kperio, kni, knj
      REAL (kind=rl), DIMENSION (kni * knj), INTENT (inout) :: ptab
      REAL (kind=rl), DIMENSION (kni, knj) :: ztab
      CHARACTER(len=1), INTENT( in ) ::   cd_type
      INTEGER (kind=il) ::   ji, ijt, iju
      !!----------------------------------------------------------------------
      IF (kperio == 0_il) RETURN
      ztab = RESHAPE (ptab, (/ kni, knj /) )
      !                                       
      SELECT CASE ( kperio )                   ! East-West boundaries
      CASE ( 1 , 4 , 6 )                       ! * cyclic east-west
         ztab( 1 ,:) = ztab(kni-1,:)
         ztab(kni,:) = ztab(  2  ,:)
      END SELECT
      !                                        ! ======================
      SELECT CASE ( kperio )                   ! North-South boundaries

      CASE ( 2 )                               ! * South symmetric
         SELECT CASE ( cd_type )
         CASE ( 'T' , 'U' , 'W' )                
            ztab(:, 1 ) = ztab(:,3)
         CASE ( 'V' , 'F' , 'I' )               
            ztab(:, 1 ) = ztab(:,2)
         END SELECT
      CASE ( 3 , 4 )                            ! * North fold  T-point pivot
         SELECT CASE ( cd_type )
         CASE ( 'T' , 'W' ) 
            ztab (2      :kni  , knj  ) = ztab (kni    :2:-1, knj-2)
            ztab (kni/2+1:kni  , knj-1) = ztab (kni/2+1:2:-1, knj-1)                           ! T-, W-point
         CASE ( 'U' ) 
            ztab (1      :kni-1, knj  ) = ztab (kni    :2:-1, knj-2)
            ztab (kni/2  :kni-1, knj-1) = ztab (kni/2+1:2:-1, knj-1)
         CASE ( 'V' )
            ztab (2      :kni  , knj-1) = ztab (kni    :2:-1, knj-2)
            ztab (2      :kni  , knj  ) = ztab (kni    :2:-1, knj-3)
         CASE ( 'F' )
            ztab (1      :kni-1, knj  ) = ztab (kni    :2:-1, knj-3)
            ztab (1      :kni-1, knj-1) = ztab (kni    :2:-1, knj-2)
         END SELECT
      CASE ( 5 , 6 )                           ! * North fold  F-point pivot
         SELECT CASE ( cd_type )
         CASE ( 'T' , 'W' ) 
            ztab (1       :kni , knj  ) = ztab (kni        :1:-1, knj-1)
         CASE ( 'U' )                                  ! U-point
            ztab (1      :kni-1, knj  ) = ztab (kni-1      :1:-1, knj-1)
         CASE ( 'V' ) 
            ztab (1      :kni  , knj  ) = ztab (kni        :1:-1, knj-2)
            ztab (kni/2+1:kni  , knj-1) = ztab (kni-kni/2  :1:-1, knj-1)
         CASE ( 'F' ) 
            ztab (1      :kni-1, knj  ) = ztab (kni-1      :1:-1, knj-2)
            ztab (kni/2+1:kni-1, knj-1) = ztab (kni-kni/2-1:1:-1, knj-1)
         END SELECT
      CASE ( -1) ! LMDz type boundary conditions
         ztab (2:kni, 1  ) = ztab (1, 1  )
         ztab (2:kni, knj) = ztab (1, knj)
      END SELECT
      !
      ptab = RESHAPE (ztab, (/ kni * knj /) )
   END SUBROUTINE lbc_r
   !
   SUBROUTINE lbc_i (ktab, kperio, cd_type, kni, knj) 
      INTEGER (kind=il), INTENT (in) :: kperio, kni, knj
      INTEGER (kind=il), DIMENSION (kni * knj), INTENT (inout) :: ktab
      INTEGER (kind=il), DIMENSION (kni, knj) :: itab
      CHARACTER(len=1), INTENT( in ) ::   cd_type
      INTEGER (kind=il) ::   ji, ijt, iju
      !!----------------------------------------------------------------------
      IF (kperio == 0_il) RETURN
      itab = RESHAPE (ktab, (/ kni, knj /) )
      !                                       
      SELECT CASE ( kperio )                   ! East-West boundaries
      CASE ( 1 , 4 , 6 )                       ! * cyclic east-west
         itab( 1 ,:) = itab(kni-1,:)
         itab(kni,:) = itab(  2  ,:)
      END SELECT
      !                                        ! ======================
      SELECT CASE ( kperio )                   ! North-South boundaries

      CASE ( 2 )                               ! * South symmetric
         SELECT CASE ( cd_type )
         CASE ( 'T' , 'U' , 'W' )                
            itab(:, 1 ) = itab(:,3)
         CASE ( 'V' , 'F' , 'I' )               
            itab(:, 1 ) = itab(:,2)
         END SELECT
      CASE ( 3 , 4 )                            ! * North fold  T-point pivot
         SELECT CASE ( cd_type )
         CASE ( 'T' , 'W' ) 
            itab (2      :kni  , knj  ) = itab (kni    :2:-1, knj-2)
            itab (kni/2+1:kni  , knj-1) = itab (kni/2+1:2:-1, knj-1)                           ! T-, W-point
         CASE ( 'U' ) 
            itab (1      :kni-1, knj  ) = itab (kni    :2:-1, knj-2)
            itab (kni/2  :kni-1, knj-1) = itab (kni/2+1:2:-1, knj-1)
         CASE ( 'V' )
            itab (2      :kni  , knj-1) = itab (kni    :2:-1, knj-2)
            itab (2      :kni  , knj  ) = itab (kni    :2:-1, knj-3)
         CASE ( 'F' )
            itab (1      :kni-1, knj  ) = itab (kni    :2:-1, knj-3)
            itab (1      :kni-1, knj-1) = itab (kni    :2:-1, knj-2)
         END SELECT
      CASE ( 5 , 6 )                           ! * North fold  F-point pivot
         SELECT CASE ( cd_type )
         CASE ( 'T' , 'W' ) 
            itab (1       :kni , knj  ) = itab (kni        :1:-1, knj-1)
         CASE ( 'U' ) 
            itab (1      :kni-1, knj  ) = itab (kni-1      :1:-1, knj-1)
         CASE ( 'V' )                                  ! V-point
            itab (1      :kni  , knj  ) = itab (kni        :1:-1, knj-2)
            itab (kni/2+1:kni  , knj-1) = itab (kni-kni/2  :1:-1, knj-1)
         CASE ( 'F' )
            itab (1      :kni-1, knj  ) = itab (kni-1      :1:-1, knj-2)
            itab (kni/2+1:kni-1, knj-1) = itab (kni-kni/2-1:1:-1, knj-1)
         END SELECT
      CASE ( -1) ! LMDz type boundary conditions
         itab (2:kni, 1  ) = itab (1, 1  )
         itab (2:kni, knj) = itab (1, knj)
      END SELECT
      !
      ktab = RESHAPE (itab, (/ kni * knj /) )
   END SUBROUTINE lbc_i
   !
   SUBROUTINE lbc_l (ltab, kperio, cd_type, kni, knj) 
      INTEGER (kind=il), INTENT (in) :: kperio, kni, knj
      LOGICAL, DIMENSION (kni * knj), INTENT (inout) :: ltab
      LOGICAL, DIMENSION (kni, knj) :: itab
      CHARACTER(len=1), INTENT( in ) ::   cd_type
      INTEGER (kind=il) ::   ji, ijt, iju
      !!----------------------------------------------------------------------
      IF (kperio == 0_il) RETURN
      itab = RESHAPE (ltab, (/ kni, knj /) )
      !                                       
      SELECT CASE ( kperio )                   ! East-West boundaries
      CASE ( 1 , 4 , 6 )                       ! * cyclic east-west
         itab( 1 ,:) = itab(kni-1,:)
         itab(kni,:) = itab(  2  ,:)
      END SELECT
      !                                        ! ======================
      SELECT CASE ( kperio )                   ! North-South boundaries

      CASE ( 2 )                               ! * South symmetric
         SELECT CASE ( cd_type )
         CASE ( 'T' , 'U' , 'W' )                
            itab(:, 1 ) = itab(:,3)
         CASE ( 'V' , 'F' , 'I' )               
            itab(:, 1 ) = itab(:,2)
         END SELECT
      CASE ( 3 , 4 )                            ! * North fold  T-point pivot
         SELECT CASE ( cd_type )
         CASE ( 'T' , 'W' ) 
            itab (2      :kni  , knj  ) = itab (kni    :2:-1, knj-2)
            itab (kni/2+1:kni  , knj-1) = itab (kni/2+1:2:-1, knj-1) 
         CASE ( 'U' )
            itab (1      :kni-1, knj  ) = itab (kni    :2:-1, knj-2)
            itab (kni/2  :kni-1, knj-1) = itab (kni/2+1:2:-1, knj-1)
         CASE ( 'V' )
            itab (2      :kni  , knj-1) = itab (kni    :2:-1, knj-2)
            itab (2      :kni  , knj  ) = itab (kni    :2:-1, knj-3)
         CASE ( 'F' )
            itab (1      :kni-1, knj  ) = itab (kni    :2:-1, knj-3)
            itab (1      :kni-1, knj-1) = itab (kni    :2:-1, knj-2)
         END SELECT
      CASE ( 5 , 6 )                           ! * North fold  F-point pivot
         SELECT CASE ( cd_type )
         CASE ( 'T' , 'W' ) 
            itab (1       :kni , knj  ) = itab (kni        :1:-1, knj-1)
         CASE ( 'U' ) 
            itab (1      :kni-1, knj  ) = itab (kni-1      :1:-1, knj-1)
         CASE ( 'V' )
            itab (1      :kni  , knj  ) = itab (kni        :1:-1, knj-2)
            itab (kni/2+1:kni  , knj-1) = itab (kni-kni/2  :1:-1, knj-1)
         CASE ( 'F' )
            itab (1      :kni-1, knj  ) = itab (kni-1      :1:-1, knj-2)
            itab (kni/2+1:kni-1, knj-1) = itab (kni-kni/2-1:1:-1, knj-1)
         END SELECT
      CASE ( -1) ! LMDz type boundary conditions
         itab (2:kni, 1  ) = itab (1, 1  )
         itab (2:kni, knj) = itab (1, knj)
      END SELECT
      !
      ltab = RESHAPE (itab, (/ kni * knj /) )
   END SUBROUTINE lbc_l
   !!
END MODULE mod_lbc_2

