! -*- Mode: f90 -*-
MODULE mod_polyw_a
CONTAINS
   SUBROUTINE polyw_a (lo2a, la2o)
      !>
      !! Compute weights by exact by distance
      !!
      USE declare
      USE modeles
      USE math
      USE formula
      USE mod_proj
      USE u_polyg
      USE mod_polom
      USE mod_lbc
      !!
      IMPLICIT NONE
      !!
      REAL (kind=rd), DIMENSION (:), ALLOCATABLE :: xa, ya
      REAL (kind=rd), DIMENSION (:), ALLOCATABLE :: xo, yo !> Polygons coordinates (last is center of polygon)
      REAL (kind=rd) :: xp, yp !> Pole of projection

      REAL (kind=rp) :: zra, zro, zr !> Radius of projected boxes 
      REAL (kind=rp) :: zga, zgo, zg !> Radius of boxes 
      REAL (kind=rd) :: zsa, zso, zs !> Surface of boxes (in cartesian coordinates)
      REAL (kind=rp), DIMENSION (:), ALLOCATABLE :: xat_p, yat_p

      INTEGER (kind=il) :: kproj = 2 !> Type of projection
      INTEGER (kind=il) :: kaerr(jpae), koerr(jpoe) !> Error code of projection
      INTEGER (kind=il) :: ja, jo, jo2, jai, jaj, joi, joj, jn, nto, no !> Dummy indexes
      LOGICAL (kind=il) :: lwrite  !> For test outputs
      INTEGER (kind=il) :: ld = 1 , ld_t !> Debug flag
      INTEGER (kind=il) :: np=0 ! Comptage de print
      REAL (kind = rl) :: xoloninf, xolonsup, yolatinf, yolatsup
      REAL (kind = rl) :: xaloninf, xalonsup, yalatinf, yalatsup
      REAL (kind=rl) :: dx, dy
      LOGICAL, INTENT (in) :: lo2a, la2o
      REAL (kind=rl), DIMENSION (:), ALLOCATABLE :: xat_n, yat_n, xat_s, yat_s
      INTEGER (kind=il) :: kerr_p(jpai+1) !> Error code of projection
      LOGICAL :: la_nor, la_sud
      !!
      ALLOCATE (xa (jpae))
      ALLOCATE (ya (jpae))
      ALLOCATE (xo (jpoe))
      ALLOCATE (yo (jpoe))
      !!
      !!
      IF ( la_pole ) THEN ! Bug, uniquement pour grille reguliere ...
         ALLOCATE (xat_n(jpai+1))
         ALLOCATE (yat_n(jpai+1))
         ALLOCATE (xat_s(jpai+1))
         ALLOCATE (yat_s(jpai+1))
         ALLOCATE (xat_p(jpai+1))
         ALLOCATE (yat_p(jpai+1))
         DO jai = 1, jpai
            IF ( la_nortop ) THEN
               xat_s (jai) = xae ( m1a(jpai-jai+1, 1    ) )
               xat_n (jai) = xaw ( m1a(jai       , jpaj ) )
               yat_s (jai) = yan ( m1a(jpai      , 1    ) )
               yat_n (jai) = yas ( m1a(jpai-jai+1, jpaj ) )
            ELSE
               xat_s (jai) = xae ( m1a(jai       , jpaj ) )
               xat_n (jai) = xaw ( m1a(jpai-jai+1, 1    ) )
               yat_s (jai) = yan ( m1a(jpai      , jpaj ) )
               yat_n (jai) = yas ( m1a(jpai-jai+1, 1    ) )
            END IF
         END DO

         xat_s (jpai+1) =   0.0_rl
         xat_n (jpai+1) =   0.0_rl

         yat_s (jpai+1) = -90.0_rl
         yat_n (jpai+1) =  90.0_rl

         WRITE (nout,*) "xat_s : ", xat_s
         WRITE (nout,*) "yat_s : ", yat_s
         WRITE (nout,*) "xat_n : ", xat_n
         WRITE (nout,*) "yat_n : ", yat_n

      END IF
      !!
      !! Generation of weights
      !!
      ! Initialisation
      nto = 0
      IF ( lo2a ) THEN 
         jmo2a = 0 ; wo2a = zero ; ko2a = 0 ; nva = 0
      END IF
      IF ( la2o ) THEN 
         jma2o = 0 ; wa2o = zero ; ka2o = 0 ; nvo = 0
      ENDIF
      nborda = 0 ; nbordo = 0
      zra = zero ; zro = zero ; zsa = zero ; zso = zero ; zs = zero
      WRITE (unit = nout, fmt = *)
      WRITE ( unit = nout, fmt = *) 'Number of points to compute : ', jpan
      !
      !dx = 4.0_rl * 360.0_rl / REAL ( MIN ( jpai, jpaj, jpoi, jpoj), kind=rl)
      !dy = 4.0_rl * 180.0_rl / REAL ( MIN ( jpai, jpaj, jpoi, jpoj), kind=rl)
      
      dx = MAXVAL ( ABS (xae-xaw))
      dy = MAXVAL ( ABS (yan-yas))
      WRITE(nout,*) 'polyw_a : dx, dy : ', dx, dy

      !!
      !! Atmosphere
      OPEN ( unit = 36, file = 'poly.atm', form = 'formatted', status ='unknown', action = 'write', position = 'rewind' )
      !! Ocean
      OPEN (unit = 37, file = 'poly.oce', form = 'formatted', status ='unknown', action = 'write', position = 'rewind' )
      !!
      !
      AtmosJ: DO jaj = 1, jpaj ! Loop over atmospheric grid points
         ja = m1a (1, jaj)
         AtmosI: DO jai = 1, jpai
            ja = m1a (jai, jaj)
            la_nor  =.FALSE. ; la_sud = .FALSE.
            ld_t = ld
            lwrite = .FALSE. 
            no = 0
            IF (ld_t <= 1) THEN
               WRITE (UNIT=nout, FMT='(1I8," ")', ADVANCE='no') ja
               np=np+1
               IF (np > 15 ) THEN
                  WRITE (UNIT=nout, FMT='(" ")') 
                  CALL FLUSH(nout)                  
                  np=0
               END IF
            ENDIF
            xalonsup = MAXVAL (xa_ed(ja,1:jpae))
            xaloninf = MINVAL (xa_ed(ja,1:jpae)) 
            yalatsup = MAXVAL (ya_ed(ja,1:jpae))
            yalatinf = MINVAL (ya_ed(ja,1:jpae)) 
            
            IF ( yalatinf < -89.99_rl ) la_sud = .TRUE.
            IF ( yalatsup >  89.99_rl ) la_nor = .TRUE.
            
            !IF ( la_pole .AND. la_nor ) ld_t = 3

            IF (iamskt (ja) == 1 .AND. .NOT. lmaska) THEN ! This point is not considered
               IF (ld_t >= 2)  WRITE ( nout, fmt ='("rejected (Atm masked)",1I6,2I4)' ) ja, jai, jaj
               CYCLE  AtmosI
            END IF
            IF (iamskp (ja) .EQ. 1 ) THEN  ! Periodicity point rejected
               IF ( ld_t >= 4 ) WRITE (nout, fmt ='("rejected (Atm perio)",1I6,2I4)' ) ja, jai, jaj
               CYCLE AtmosI
            END IF

            IF ( la_pole .AND. la_nor ) WRITE (nout,*) 'LMD North Pole'
            IF ( la_pole .AND. la_sud ) WRITE (nout,*) 'LMD South Pole'

            IF (      la_pole .AND. la_nor ) THEN
               xalonsup = MAXVAL (xat_n)
               xaloninf = MINVAL (xat_n)
               yalatsup = 90.0_rl
               yalatinf = MINVAL ( yat_n)
            ELSE IF ( la_pole .AND. la_sud ) THEN
               xalonsup = MAXVAL (xat_s)
               xaloninf = MINVAL (xat_s)
               yalatsup = -90.0_rl
               yalatinf = MAXVAL ( yat_n)
            END IF

            IF (ld_t >= 2)  WRITE ( nout, fmt ='("Working on atm : ", 1I6,2I4,6F8.1,2I2)' ) &
               & ja, jai, jaj, xa_ed(ja,jpae), ya_ed(ja,jpae), xaloninf, xaloninf, yalatinf, yalatsup, iamskt (ja), iamskp (ja)

            IF ( xaloninf > xo_sup+dx .OR. xalonsup < xo_inf-dx ) THEN ! This point is not considered
               IF (ld_t >= 2)  WRITE ( nout, fmt ='("rejected (Atm point outside oce latitude limits )",1I6,2I4,2F8.1)' ) &
                  & ja, jai, jaj, yalatinf, yalatsup 
               CYCLE  AtmosI
            END IF
            IF ( yalatinf > yo_sup+dy .OR. yalatsup < yo_inf-dy ) THEN ! This point is not considered
               IF (ld_t >= 2)  WRITE ( nout, fmt ='("rejected (Atm point outside oce longitude limits)",1I6,2I4,2F8.1)' ) &
                  &ja, jai, jaj, xaloninf, xaloninf
               CYCLE  AtmosI
            END IF
       
            !!
            zga = 0.0_rl
           
            IF (      la_pole .AND. la_nor ) THEN 
               DO jn = 1, jpai
                  zga = MAX (zga, cartdist (xat_n(jn), yat_n(jn), 0.0_rl,  90.0_rl ))
               END DO
            ELSE IF (      la_pole .AND. la_sud ) THEN 
               DO jn = 1, jpai
                  zga = MAX (zga, cartdist (xat_s(jn), yat_s(jn), 0.0_rl, -90.0_rl ))
               END DO
            ELSE
               DO jn = 1, jpae-1
                  zga = MAX (zga, cartdist (xa_ed(ja,jn), ya_ed(ja,jn), xa_ed(ja,jpae), ya_ed(ja,jpae) ) )
            END DO
            END IF

            !! Project atm edges
            IF (      la_pole .AND. la_sud ) THEN
               xp = xat_s (jpai+1) ; yp = yat_s (jpai+1)
            ELSE IF ( la_pole .AND. la_nor ) THEN 
               xp = xat_n (jpai+1) ; yp = yat_n (jpai+1)
            ELSE
               xp = xa_ed (ja,jpae) ; yp = ya_ed (ja,jpae) ! Projection pole : center of atmospherix box
            END IF
            IF (ld_t >= 2) WRITE (nout, fmt ='("working on atm : ", 1I6,2I4,11(2F8.1))') &
               & ja, jai, jaj, xa_ed(ja,:), ya_ed(ja,:), yalatinf, yalatsup
            DO jn = 1, jpae
               CALL proj ( xa_ed(ja,jn), ya_ed(ja,jn), xp, yp, xa(jn), ya(jn), kproj, kaerr(jn) ) ! Project atm box
            END DO
            !! Radius of atmospheric box in cartesian coordinates
            zra = 0.0_rl
            DO jn = 1, jpae-1
               zra = MAX ( zra, ddist (xa(jn), ya(jn), xa(jpae), ya(jpae)) )
            END DO
            !!
            OceanJ: DO joj = 1, jpoj
               jo = m1o ( 1, joj) 
               OceanI: DO joi = 1, jpoi
                  jo = m1o ( joi, joj) 
                  !!
                  ! Masked point
                  IF ( iomskt (jo) .EQ. 1 .AND. .NOT. lmasko) THEN
                     IF (ld_t >= 4) WRITE (nout, fmt ='("rejected (Oce masked)",2(1I6,2I4))') ja, jai, jaj, jo, joi, joj
                     IF (ld_t >= 4) WRITE (nout, fmt ='("rejected (mask ) : ",2(1I6,2I4,2F8.1,1F8.4))') & 
                        & ja, jai, jaj, xp, yp, zra, jo, joi, joj, xo_ed(jo,jpoe), yo_ed(jo,jpoe), zro
                     CYCLE OceanI
                  END IF
                  
                  ! Periodicity
                  IF (iomskp (jo) .EQ. 1 ) THEN  ! Periodicity point rejected
                     IF (ld_t >= 4) WRITE ( nout, fmt ='("rejected (Oce perio) : ",2(1I6,2I4,2F8.1,1F8.4))') &
                        & ja, jai, jaj, xp, yp, zra, jo, joi, joj, xo_ed(jo,jpoe), yo_ed(jo,jpoe), zro
                     CYCLE OceanI
                  END IF
                  !
                  ld_t = ld
                  !
                  !IF (ld_t <= 1) THEN
                  !   WRITE (UNIT=nout, FMT='("jo=",1I8," ")', ADVANCE='no') jo
                  !   CALL FLUSH(nout)
                  !ENDIF
                  !
                  xolonsup = MAXVAL(xo_ed(jo,:))
                  xoloninf = MINVAL(xo_ed(jo,:)) 
                  yolatsup = MAXVAL(yo_ed(jo,:))
                  yolatinf = MINVAL(yo_ed(jo,:)) 
                  IF ( yolatsup > 85.0_rl ) yolatsup = 90.0_rl
                  !IF ( joj == jpoj-1 .AND. yolatsup > 87.0_rl .AND. yalatsup > 85.0_rl) ld_t = 3

                  ! Latitude limits criterion
                  IF ( dehors (yalatinf-dy, yalatsup+dy, yolatinf-dy, yolatsup+dy) ) THEN ! Boxes do not overlap
                     IF (ld_t >= 3) WRITE ( nout, fmt ='("rejected (lat) : ",2(1I6,2I4,4F8.2))') & 
                        & ja, jai, jaj, xa_ed(ja,jpae), ya_ed(ja,jpae), yalatinf, yalatsup, & 
                        & jo, joi, joj, xo_ed(jo,jpoe), yo_ed(jo,jpoe), yolatinf, yolatsup
                     CYCLE OceanI
                  END IF
                
                  !!
                  zgo = 0.0_rd
                  DO jn = 1, jpoe-1
                     zgo = MAX (zgo, cartdist (xo_ed(jo,jn), yo_ed(jo,jn), xo_ed(jo,jpoe), yo_ed(jo,jpoe)))
                  ENDDO

                  !! Geographical distance criterion
                  zg = REAL (cartdist (xa_ed(ja,jpae), ya_ed(ja,jpae), xo_ed(jo,jpoe), yo_ed(jo,jpoe)),KIND=rd)
                  IF (zg .GE. 1.2_rd * (zgo + zga)) THEN ! Boxes do not overlap
                     IF (ld_t >= 3) WRITE (nout, fmt ='("rejected (cartdist) : ",2(1I6,2I4,2F8.1,1E14.3),1E14.3)') & 
                        & ja, jai, jaj, xa_ed(ja,jpae), ya_ed(ja,jpae), zga, &
                        & jo, joi, joj, xo_ed(jo,jpoe), yo_ed(jo,jpoe), zgo, &
                        & zg
                     CYCLE OceanI
                  END IF
                  !! Project ocean edges
                  DO jn = 1, jpoe
                     CALL proj ( xo_ed(jo,jn), yo_ed(jo,jn), xp, yp, xo(jn), yo(jn), kproj, koerr(jn) )
                  END DO
                  IF ( SUM(koerr) /= 0 ) THEN
                     IF ( ld >= 2) WRITE ( nout, fmt ='("rejected (kerr) : ",2(1I6,2I4,2F8.1,1F8.4))') &
                        & ja, jai, jaj, xp, yp, zra, jo, joi, joj, xo_ed(jo,jpoe), yo_ed(jo,jpoe), zro
                     CYCLE OceanI
                  END IF
                  IF (ld_t >= 3) THEN 
                     WRITE (nout, fmt ='("working on oce : ", 1I6,2I4,4F8.1)') jo, joi, joj, xoloninf, xolonsup, yolatinf, yolatsup
                  END IF
                  !! Distance criterion
                  zro = 0.0_rd
                  DO jn = 1, jpoe - 1
                     zro = MAX (zro, ddist (xo(jn), yo(jn), xo(jpoe), yo(jpoe)))
                  END DO
                  zr = ddist (xa(jpae), ya(jpae), xo(jpoe), yo(jpoe)) ! Distance between center of atm and oce grid boxes
                  IF (zr .GE. 5.0 * (zro + zra)) THEN ! Boxes do not overlap
                     IF (ld_t >= 3) WRITE (nout, &
                        & fmt ='("rejected (dist) : ", 1I6,2I4,2F8.1,1F8.4, 1I6, 2I4, 2F8.1, 1F8.4)') & 
                        & ja, jai, jaj, xa_ed(ja,jpae), ya_ed(ja,jpae), zra, jo, joi, joj, xp, yp, zro
                     CYCLE OceanI
                  END IF
                  IF (ld_t >=3) WRITE (nout, fmt ='("accepted : ", 2(1I6,2I4,2F8.1,1E13.4),1E13.4)' ) &
                     & ja, jai, jaj, xa_ed(ja,jpae), ya_ed(ja,jpae), zra, & 
                     & jo, joi, joj, xo_ed(jo,jpoe), yo_ed(jo,jpoe), zro, &
                     & zr 
                  !! Find surface of intersection. Surface is given as the ratio between intersection and atm box
                  IF ( la_pole ) THEN
                     !! Special handling at poles
                     IF      ( yalatinf < -89.99_rl ) THEN 
                        DO jn = 1, jpai+1
                           CALL proj (xat_s(jn), yat_s(jn), xp, yp, xat_p(jn), yat_p(jn), kproj, kerr_p(jn))
                        ENDDO
                        CALL polom (xat_p, yat_p, xo, yo, zsa, zso, zs)
                     ELSE IF ( yalatsup >  89.99_rl ) THEN 
                        DO jn = 1, jpai+1
                           CALL proj (xat_n(jn), yat_n(jn), xp, yp, xat_p(jn), yat_p(jn), kproj, kerr_p(jn))
                        END DO
                        CALL polom (xat_p, yat_p, xo, yo, zsa, zso, zs)
                     ELSE 
                        CALL polom (xa, ya, xo, yo, zsa, zso, zs)
                     ENDIF
                  ELSE
                     CALL polom  (xa, ya, xo, yo, zsa, zso, zs) 
                  ENDIF
                  !!
                  IF ( zs < zeps ) THEN ! Boxes do not overlap
                     IF (ld >= 3 ) WRITE ( nout, fmt ='("rejected (poly) : ",2(1I6,2I4,2F8.1),1E13.4)') & 
                        & ja, jai, jaj, xa_ed(ja,jpae), ya_ed(ja,jpae), &
                        & jo, joi, joj, xo_ed(jo,jpoe), yo_ed(jo,jpoe), &
                        & zs
                     CYCLE OceanI
                  END IF
                  IF (ld_t >= 2) WRITE ( nout, fmt ='("accepted (final) : ",2(1I6,2I4,2F8.1,1E13.4),3(1PE13.4))') &
                     & ja, jai, jaj, xa_ed(ja,jpae), ya_ed(ja,jpae), zra, &
                     & jo, joi, joj, xo_ed(jo,jpoe), yo_ed(jo,jpoe), zro, &
                     & zsa, zso, zs
                  !!
                  IF (ld_t >= 3) THEN 
                     WRITE (nout, fmt = '(9E10.2)') xa(:)
                     WRITE (nout, fmt = '(9E10.2)') ya(:)
                     WRITE (nout, fmt = '(9E10.2)') xo(:)
                     WRITE (nout, fmt = '(9E10.2)') yo(:)
                  END IF
                  IF (lo2a) THEN 
                     IF ( nva (ja) >= jpo2a ) THEN
                        WRITE ( unit = nout, fmt = '("Not enough oce neighbors in : ", 3I6, 5F8.1)' ) &
                           & jai, jaj, nva(ja), xa_ed(ja,jpae), ya_ed(ja,jpae), yalatinf, yalatsup
                        WRITE ( unit = nout, fmt = *)  'xa_ed : ', xa_ed(ja,:)
                        WRITE ( unit = nout, fmt = *)  'ya_ed : ', ya_ed(ja,:)
                        WRITE ( unit = nout, fmt = *) "xp, yp : ", xp, yp
                        WRITE ( unit = nout, fmt = *) "xa : ", xa
                        WRITE ( unit = nout, fmt = *) "ya : ", ya
                        WRITE (nout, fmt = *) &
                           & "jn,jo2,m2oi(jo2),m2oj(jo2),wo2a(jn,ja), ", &
                           & "xo_ed(jo2,jpoe),yo_ed(jo2,jpoe),xo_ed(jo2,:),yo_ed(jo2,:)"
                        DO jn = 1, nva (ja) 
                           jo2 = ko2a (jn,ja)
                           WRITE (nout, fmt = *) &
                              & jn,jo2,m2oi(jo2),m2oj(jo2),wo2a(jn,ja), &
                              & xo_ed(jo2,jpoe),yo_ed(jo2,jpoe),xo_ed(jo2,:),yo_ed(jo2,:)
                        END DO
                        STOP
                        EXIT OceanI
                     END IF
                     !
                     nva(ja) = nva(ja) + 1
                     jmo2a = MAX (jmo2a, nva(ja))
                     ko2a (nva(ja), ja) = jo 
                     ! Weights : surface of intersection
                     wo2a (nva(ja), ja) = REAL (zs, KIND = rl)
                     IF ( wo2a (nva(ja), ja) > 1.0_rl+SQRT(epsfrac) ) THEN 
                        WRITE ( nout, fmt='("o2a >1 ",2(1I6,2I3, 2F8.1),1I3,1E13.4)' )  &
                           &  ja,jai,jaj, xa_ed(ja,jpae), ya_ed(ja,jpae)&
                           &, jo,joi,joj, xo_ed(ja,jpae), yo_ed(jo,jpoe), jn, wo2a(nva(ja),ja)
                        WRITE (nout, fmt = '("xa : ", 9E10.2)') xa(:)
                        WRITE (nout, fmt = '("ya : ", 9E10.2)') ya(:)
                        WRITE (nout, fmt = '("xo : ", 9E10.2)') xo(:)
                        WRITE (nout, fmt = '("yo : ", 9E10.2)') yo(:)
                        WRITE (nout, fmt = '("surface : ", 9E10.2)') xosrft(ja), xasrft (ja), zro, zra, zgo, zga, zso, zsa, zs
                     END IF
                  END IF
                  !
                  IF (la2o) THEN 
                     IF (nvo (jo) >= jpa2o ) THEN
                        WRITE (unit = nout, fmt = '("Not enough atm neighbors in : ", 3I6, 6F8.1)' ) &
                           &  joi, joj, nvo(jo), xolont(jo), xolatt(jo), yolatinf, yolatsup
                        WRITE (unit = nout, fmt = *) jai, jaj, nva(ja), xa_ed(ja,jpae), ya_ed(ja,jpae), yalatinf, yalatsup
                        WRITE (unit = nout, fmt = *)  'xa_ed : ', xa_ed(ja,:)
                        WRITE (unit = nout, fmt = *)  'ya_ed : ', ya_ed(ja,:)
                        WRITE (unit = nout, fmt = *)  'xo_ed : ', xo_ed(ja,:)
                        WRITE (unit = nout, fmt = *)  'yo_ed : ', yo_ed(ja,:)
                        WRITE (unit = nout, fmt = *) zs
                        STOP
                        EXIT OceanI
                     ENDIF
                     nvo (jo) = nvo (jo) + 1
                     jma2o = MAX (jma2o, nvo (jo))
                     ka2o (nvo(jo), jo) = ja
                     !! Choix entre 2 formules de calcul
                     !wa2o = zs * zsa / zso
                     wa2o (nvo(jo), jo) = zs * xasrft(ja) / xosrft(jo)
!-$$                     IF (wa2o (nvo (jo), jo) > 1.0_rl+epsfrac ) THEN 
!-$$                        WRITE (nout, fmt='("a2o >1 ",2(1I6,2I4),1I4,1E13.4)' ) &
!-$$                           & ja,jai,jaj,jo,joi,joj,jn,wa2o(nvo(jo),jo)
!-$$                        WRITE (nout, fmt = '(9E10.2)') xa(:)
!-$$                        WRITE (nout, fmt = '(9E10.2)') ya(:)
!-$$                        WRITE (nout, fmt = '(9E10.2)') xo(:)
!-$$                        WRITE (nout, fmt = '(9E10.2)') yo(:)
!-$$                     END IF
                     !!
                  ENDIF
                  no = no + 1
                  !
               END DO OceanI
            END DO OceanJ
            nto = no + nto 
         END DO AtmosI
      END DO AtmosJ
      !!
      WRITE ( nout, fmt = '("Total points : ", 1I6 , ", Average : ", 1F9.3, " oce points per atm point" )' ) &
         & nto, REAL(nto,KIND=rl) / REAL(jpan,KIND=rl)
      !!
      IF (la2o) THEN 
         jma2o = MAXVAL (nvo)
         jma2o = MIN (jma2o, jpa2o)
      ENDIF
      IF (lo2a) THEN 
         jmo2a = MAXVAL (nva)
         jmo2a = MIN (jmo2a, jpo2a)
      END IF
      !!
      WRITE (nout, fmt = *) jpa2o, jma2o, jpo2a, jmo2a
      !!
      CLOSE (unit = 36)
      CLOSE (unit = 37)
      !!
   END SUBROUTINE polyw_a
END MODULE mod_polyw_a
