! -*- Mode: f90 -*-
MODULE mod_polyw_a_fast
CONTAINS
   SUBROUTINE polyw_a_fast (lo2a, la2o)
!!! 
!!! Compute weights fastly
!!!
      USE declare
      USE modeles
      USE math
      USE formula
      USE mod_proj
      !!
      IMPLICIT NONE
      !!
      INTEGER (kind=il) :: ja, jo, jo2, jai, jaj, joi, joj, jn, nto, no ! Dummy indexes
      LOGICAL (kind=il) :: lwrite  ! For test outputs
      INTEGER (kind=il) :: ld = 1 , ld_t ! Debug flag
      REAL (kind=rl) :: zmin
      LOGICAL, INTENT (in) :: lo2a, la2o
      !!
      !! Generation of weights
      !!
      ! Initialisation
      nto = 0
      IF ( lo2a ) THEN 
         jmo2a = 0 ; wo2a = zero ; ko2a = 0 ; nva = 0
      END IF
      IF ( la2o ) THEN 
         jma2o = 0 ; wa2o = zero ; ka2o = 0 ; nvo = 0
      ENDIF
      WRITE (unit = nout, fmt = *)
      WRITE ( unit = nout, fmt = *) 'Number of points to compute : ', jpan
      !
      !!
      Atmos: DO ja = 1, jpan, 1 ! Loop over atmospheric grid points
         ld_t = ld
         lwrite = .FALSE. 
         no = 0
         jai = m2ai(ja) ; jaj = m2aj(ja)   ! 2D indexes of atm box
         yalatsup = MAXVAL (ya_ed(ja:ja,1:jpae))
         yalatinf = MINVAL (ya_ed(ja:ja,1:jpae)) 
         IF (iamskt (ja) == 1 .AND. .NOT. lmaska) THEN ! This point is not considered
            IF (ld >= 4)  WRITE ( nout, fmt ='("rejected (Atm masked)",1I6,2I4)' ) ja, jai, jaj
            CYCLE  Atmos
         END IF
         IF (iamskp (ja) .EQ. 1_il ) THEN  ! Periodicity point rejected
            IF ( ld_t >= 4 ) WRITE (nout, fmt ='("rejected (Atm perio)",1I6,2I4)' ) ja, jai, jaj
            CYCLE Atmos
         END IF
         zmin = REAL (cartdist (0.0_rl, 0.0_rl, 180.0_rl, 0.0_rl), KIND=rd)
         !!
         Ocean: DO jo = 1, jpon
            !!
            joi = m2oi(jo) ; joj = m2oj(jo) ! 2D indexes
            IF ( iomskt (jo) .EQ. 1 .AND. .NOT. lmasko) THEN  ! This point is not considered
               IF (ld_t >= 4) WRITE (nout, fmt ='("rejected (Oce masked)",2(1I6,2I4))') ja, jai, jaj, jo, joi, joj
               IF (ld_t >= 4) WRITE (nout, fmt ='("rejected (mask ) : ",2(1I5,2I4,2F8.1,1F8.4))') & 
                  & ja, jai, jaj, xp, yp, zra, jo, joi, joj, xo_ed(jo,jpoe), yo_ed(jo,jpoe), zro
               CYCLE Ocean
            END IF
            IF (iomskp (jo) .EQ. 1_il ) THEN  ! Duplicated point rejected
               IF (ld_t >= 4) WRITE ( nout, fmt ='("rejected (Oce perio) : ",2(1I6,2I4,2F8.1,1F8.4))') &
                  & ja, jai, jaj, xp, yp, zra, jo, joi, joj, xo_ed(jo,jpoe), yo_ed(jo,jpoe), zro
               CYCLE Ocean 
            END IF
            ! Latitude limits criterion
            yolatsup = MAXVAL(yo_ed(jo,:)) ; yolatinf = MINVAL(yo_ed(jo,:)) 
            IF ( dehors (yalatinf-dy, yalatsup+dy, yolatinf-dy, yolatsup+dy) ) THEN ! Boxes do not overlap
               IF (ld_t >= 3) WRITE ( nout, fmt ='("rejected (lat) : ",2(1I6,2I4,4F8.2))') & 
                  & ja, jai, jaj, xa_ed(ja,jpae), ya_ed(ja,jpae), yalatinf, yalatsup, & 
                  & jo, joi, joj, xo_ed(jo,jpoe), yo_ed(jo,jpoe), yolatinf, yolatsup
               CYCLE Ocean
            END IF
            !!
            ENDDO
            !! Geographical distance criterion
            zg = REAL (cartdist (xa_ed (ja,jpae), ya_ed (ja,jpae), xo_ed (jo,jpoe), yo_ed (jo,jpoe)), KIND=rd)
            IF (zg < zmin) THEN 
               ka2o (1, jo) = ja
               ko2a (1, ja) = jo
               nvo (jo) = 1
               nva (ja) = 1
               wa2o (jo) = 1.0_rl
               wo2a (ja) = 1.0_rl
            END IF
            !
         END DO Atmos
         !!
      END DO Atmos
      !!
      WRITE ( nout, fmt = '("Total points : ", 1I5 , ", Average : ", 1F9.3, " oce points per atm point" )' ) &
         & nto, REAL(nto,KIND=rl) / REAL(jpan,KIND=rl)
      !!
      !$$$    IF ( lo2a ) THEN 
      !$$$        DO ja = 1, jpan
      !$$$          IF ( ABS ( SUM(wo2a(ja,:)) - 1.0_rl ) > SQRT(zeps) ) THEN 
      !$$$              jai = m2ai ( ja) ; jaj = m2aj ( ja) 
      !$$$              WRITE ( nout, fmt = '("pb sum : ", 3I5, " : ", 2(F9.1), " : ", 1PE15.6)' ) ja, jai, jaj, xa_ed(ja,jpae), ya_ed(ja,jpae), SUM(wo2a(ja,:))
      !$$$          END IF
      !$$$        END DO
      !$$$    ENDIF
      !!
      IF (la2o) THEN 
         jma2o = MAXVAL (nvo)
         jma2o = MIN (jma2o, jpa2o)
      ENDIF
      IF (lo2a) THEN 
         jmo2a = MAXVAL (nva)
         jmo2a = MIN (jmo2a, jpo2a)
      END IF
      !!
      WRITE (nout, fmt = *) jpa2o, jma2o, jpo2a, jmo2a
      !!
      CLOSE (unit = 36)
      CLOSE (unit = 37)
      !!
   END SUBROUTINE polyw_a
END MODULE mod_polyw_a
