! -*- Mode: f90 -*-
MODULE mod_wripoly
CONTAINS
  SUBROUTINE wripoly 
    !>
    !! Write polygones of ocean and atmosphere on a restricted area in two files, 
    !! for a later use for test of the method to find common surfaces between two polygones.
    !! 
    USE declare
    USE modeles
    USE mod_proj
    IMPLICIT NONE
    !!
    INTEGER (kind=il) :: jo, ja, jn, nn, kp, kerr(9)
    REAL (kind=rd) :: xl, xu, yl, yu, plon0, plat0
    REAL (kind=rd), DIMENSION (9) :: px, py
    !!
    !! bounds of area
    xl = 0.0_rl ; xu = 20.0_rl ; yl = 60.0_rl ; yu = 80.0_rl
    !! Pole of projection
    plon0 = 0.5 * ( xl + xu ) ; plat0 = 0.5 * ( yl + yu)
    !! Type of projection
    kp = 2
    !!
    !! Atmosphere
    OPEN ( unit = 36, file = 'poly.atm', form = 'formatted', status ='unknown', action = 'write', position = 'rewind' )
    !
    nn = 0
    DO ja = 1, jpan
      IF (       MINVAL ( xa_ed (ja,:)) .LE. xu .AND. MAXVAL ( xa_ed(ja,:)) .GE. xl &
         & .AND. MINVAL ( ya_ed (ja,:)) .LE. yu .AND. MAXVAL ( ya_ed(ja,:)) .GE. yl ) THEN
          DO jn = 1, jpae
            CALL proj ( xa_ed(ja,jn), ya_ed(ja,jn), plon0, plat0, px(jn), py(jn), kp, kerr(jn) )
          END DO
          IF ( SUM(kerr) == 0 ) THEN 
              WRITE ( unit = 36, fmt = '(16F9.4)' )  ( (/ px(jn), py(jn) /), jn = 1, jpae-1 ) 
              nn = nn + 1
          END IF
      END IF
    END DO
    CLOSE ( unit = 36)
    !!
    !! Ocean
    OPEN ( unit = 36, file = 'poly.oce', form = 'formatted', status ='unknown', action = 'write', position = 'rewind' )
    !
    nn = 0
    DO jo = 1, jpon
      IF (       MINVAL ( xo_ed (jo,:)) .LE. xu .AND. MAXVAL ( xo_ed(jo,:)) .GE. xl &
         & .AND. MINVAL ( yo_ed (jo,:)) .LE. yu .AND. MAXVAL ( yo_ed(jo,:)) .GE. yl ) THEN
          DO jn = 1, jpoe
            CALL proj ( xo_ed(jo,jn), yo_ed(jo,jn), plon0, plat0, px(jn), py(jn), kp, kerr(jn) )
          END DO
          IF ( SUM(kerr) == 0 ) THEN 
              WRITE ( unit = 36, fmt = '(16F9.4)' )  ( (/ px(jn), py(jn) /), jn = 1, jpae-1 ) 
              nn = nn + 1
          END IF
      END IF
    END DO
    CLOSE ( unit = 36)
    !!
    RETURN
    !!
  END SUBROUTINE wripoly
END MODULE mod_wripoly
